<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on August 24, 2009 at 12:28:43 pm</time-stamp>
<!-- Changes from: PV-Datachannel(Green.258.4,sourcecontrol)  to: PV-Datachannel(Green.258.7.18,bbuxton) -->


<methods>
<class-id>UI.ValueHolder</class-id> <category>accessing</category>

<body package="PV-Base Extensions" selector="valueWithArguments:">valueWithArguments: arguments

	| size |
	size := arguments size.
	size == 0 ifTrue: [^self value].
	size == 1 ifTrue: [^self value: arguments first].
	^self error: 'Too Many Arguments'</body>
</methods>


<class>
<name>SimpleSerializer</name>
<environment>PROVISO</environment>
<super>PROVISO.SimpleVisitor</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>stream isBigEndian classToIdMap idToClassMap mapVersions byteBuffer lastPosition </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-CME-ES</category>
<attributes>
<package>PV-Base Extensions</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.SimpleSerializer</class-id> <category>writing</category>

<body package="PV-Base Extensions" selector="writeSimpleSerializerStandIn:">writeSimpleSerializerStandIn: aStandIn

	^aStandIn writeTo: self</body>

<body package="PV-Base Extensions" selector="writeClass:">writeClass: aClass
	
	| id |
	id := self idForClass: aClass.
	self writeVarInt: id.
	^id</body>

<body package="PV-Base Extensions" selector="write:">write: anObject 
	"Write the class id, then visit the object"
	
	| id |
	id := (self class usesStandIn includes: anObject class) 
		ifTrue: [id := self idForClass: anObject class]
		ifFalse: [self writeClass: anObject class].
	self 
		visit: anObject
		class: (self classForId: id)
		task: #write</body>
</methods>

<methods>
<class-id>PROVISO.SimpleSerializer</class-id> <category>reading</category>

<body package="PV-Base Extensions" selector="readSimpleSerializerStandIn:">readSimpleSerializerStandIn: aStandIn

	^aStandIn readFrom: self</body>

<body package="PV-Base Extensions" selector="read">read
	
	| inst cls |
	cls := self readClass.
	inst := self instantiate: cls.
	^self 
		visit: inst
		class: cls
		task: #read</body>

<body package="PV-Base Extensions" selector="readClass">readClass
	
	^self classForId: self readVarInt</body>
</methods>


<methods>
<class-id>PROVISO.SimpleSerializer class</class-id> <category>class maps - base</category>

<body package="PV-Base Extensions" selector="baseClassMap2">baseClassMap2
	&lt;classMap: #base version: 2&gt;
	^{
		UndefinedObject.
		Object.
		Boolean.
		String.
		ByteArray.
		Symbol.
		Association.
		ArithmeticValue.
		Integer.
		SmallInteger.
		LargePositiveInteger.
		LargeNegativeInteger.
		Float.
		Double.
		Fraction.
		Array.
		OrderedCollection.
		Set.
		Dictionary.
		SimpleSerializerStandIn
	}</body>
</methods>

<methods>
<class-id>PROVISO.SimpleSerializer class</class-id> <category>utility</category>

<body package="PV-Base Extensions" selector="usesStandIn">usesStandIn

	^##(IdentitySet with: Smee.SmeeObject with: Smee.SmeeDate with: Smee.SmeeArray)</body>
</methods>

<methods>
<class-id>PROVISO.SimpleSerializer class</class-id> <category>class maps - smee</category>

<body package="PV-Base Extensions" selector="smeeClassMap2">smeeClassMap2
	&lt;classMap: #smee version: 2&gt;
	^{
		Smee.SmeeArray.
		Smee.SmeePropertyDictionary.
		Smee.SmeeDate.
		Smee.SmeeObject.
		Smee.SmeeDefaultPropertyDictionary.
		Smee.SmeeAccessor.
		Smee.SmeeAccessorProperty.
		Smee.SmeeAbstractProperty.
		Smee.SmeeDontEnumDontDeleteProperty.
		Smee.SmeeDontDeleteProperty.
		Smee.SmeeProperty.
		Smee.SmeeReadOnlyProperty.
		Smee.SmeeReadOnlyDontDeleteProperty.
		Smee.SmeeDontEnumProperty.
		Smee.SmeeReadOnlyDontEnumProperty.
		Smee.SmeeReadOnlyDontEnumDontDeleteProperty.
		Smee.SmeeBuiltinFunctionProperty.
		Smee.SmeeString.
		Smee.SmeeNullObject.
		Smee.SmeeInfinity.
		Smee.SmeeNotANumber
	}</body>
</methods>


<class>
<name>PvSystemSupport</name>
<environment>PROVISO</environment>
<super>External.ExternalInterface</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports>
			PROVISO.PvSystemSupportDictionary.*
			</imports>
<category>PV-Support</category>
<attributes>
<includeFiles></includeFiles>
<includeDirectories></includeDirectories>
<libraryFiles></libraryFiles>
<libraryDirectories><item>/usr/lib/oracle/10.1.0.3/client/lib</item> <item>/usr/lib/oracle/10.1.0.3/client/lib</item> <item>/home/bbuxton/vw/Green/258.4</item> <item>[unix]/usr/lib</item> <item>[win]$(windir)\system32</item> <item>/home/cmeshare/masters/baseGreen/linux86</item></libraryDirectories>
<beVirtual>false</beVirtual>
<optimizationLevel>debug</optimizationLevel>
<package>PV-Base Extensions</package>
</attributes>
</class>

<methods>
<class-id>Core.Collection</class-id> <category>enumerating</category>

<body package="PV-Base Extensions" selector="do:onLast:">do: eachBlock onLast: lastBlock 
	
	| previous placebo |
	placebo := Object new.
	previous := placebo.
	self do: 
		[:each | 
		previous == placebo 
			ifFalse: [eachBlock value: previous].
		previous := each].
	previous == placebo 
		ifFalse: [lastBlock value: previous]</body>
</methods>


<methods>
<class-id>Core.Error class</class-id> <category>proviso fs base</category>

<body package="PV-Base Extensions" selector="doRetryOnRetryError:">doRetryOnRetryError: aBlock

	| retryCount maxRetryCount |
	retryCount := 0.
	maxRetryCount := 8.
	^aBlock
		on: ##(Error)
		do: 
			[:ex | 
			retryCount &gt;= maxRetryCount
				ifTrue: [ex pass]
				ifFalse: [retryCount := retryCount + 1].
			(Delay forMilliseconds: 1) wait. 
			ex restart]</body>
</methods>


<methods>
<class-id>Core.PositionableStream</class-id> <category>As yet unclassified</category>

<body package="PV-Base Extensions" selector="rewindAfter:">rewindAfter: aValuable 
	
	self position ifNotNil: 
		[:savePosition | 
		^[aValuable value] 
			ensure: [self position: savePosition]]</body>
</methods>


<class>
<name>SimpleSerializerStandIn</name>
<environment>PROVISO</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>wrappee readStrategy writeStrategy </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-Base Extensions</category>
<attributes>
<package>PV-Base Extensions</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.SimpleSerializerStandIn</class-id> <category>public</category>

<body package="PV-Base Extensions" selector="writeTo:">writeTo: aSimpleSerializer 
	
	aSimpleSerializer write: readStrategy.
	aSimpleSerializer writeClass: wrappee class.
	writeStrategy value.</body>

<body package="PV-Base Extensions" selector="readFrom:">readFrom: aSimpleSerializer 
	
	| class |
	readStrategy := aSimpleSerializer read.
	class := aSimpleSerializer readClass.
	wrappee := aSimpleSerializer instantiate: class.
	^aSimpleSerializer 
		perform: readStrategy
		with: wrappee</body>
</methods>

<methods>
<class-id>PROVISO.SimpleSerializerStandIn</class-id> <category>initialize-release</category>

<body package="PV-Base Extensions" selector="initializeOn:readUsing:writeUsing:">initializeOn: anObject readUsing: aSymbol writeUsing: aBlock 
	
	wrappee := anObject.
	readStrategy := aSymbol.
	writeStrategy := aBlock</body>
</methods>


<methods>
<class-id>PROVISO.SimpleSerializerStandIn class</class-id> <category>creation</category>

<body package="PV-Base Extensions" selector="on:readUsing:writeUsing:">on: anObject readUsing: aSymbol writeUsing: aBlock 
	
	^self basicNew
		initializeOn: anObject
			readUsing: aSymbol
			writeUsing: aBlock;
		yourself</body>

<body package="PV-Base Extensions" selector="write:on:read:using:">write: anObject on: aSimpleSerializer read: aSymbol using: aBlock 
	
	| instance |
	instance := 
		self 
			on: anObject
			readUsing: aSymbol
			writeUsing: aBlock.
	^aSimpleSerializer write: instance</body>
</methods>


<methods>
<class-id>Core.Stream</class-id> <category>accessing</category>

<body package="PV-Base Extensions" selector="untilEndDo:">untilEndDo: aMonadic

	[self atEnd] whileFalse: [aMonadic value: self]</body>
</methods>


<methods>
<class-id>Core.Symbol</class-id> <category>PROVISO</category>

<body package="PV-Base Extensions" selector="value:value:">value: anObject value: another
	^anObject perform: self with: another</body>
</methods>


<class>
<name>PvUnixSystemSupport</name>
<environment>PROVISO</environment>
<super>PROVISO.PvSystemSupport</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports>
			PROVISO.PvUnixSystemSupportDictionary.*
			</imports>
<category>PV-Support</category>
<attributes>
<includeFiles><item>sys/types.h</item> <item>sys/statvfs.h</item> <item>unistd.h</item> <item>sys/stat.h</item> <item>netdb.h</item> <item>sys/systeminfo.h</item></includeFiles>
<includeDirectories><item>/usr/include</item></includeDirectories>
<libraryFiles><item>libprovisodc.so</item> <item>libc.so</item> <item>libnsl.so</item></libraryFiles>
<libraryDirectories><item>/usr/lib/oracle/10.1.0.3/client/lib</item> <item>/usr/lib/oracle/10.1.0.3/client/lib</item> <item>/home/bbuxton/vw/Green/258.4</item> <item>[unix]/usr/lib</item> <item>[win]$(windir)\system32</item> <item>/home/cmeshare/masters/baseGreen/linux86</item></libraryDirectories>
<beVirtual>false</beVirtual>
<optimizationLevel>debug</optimizationLevel>
<package>PV-Base Extensions</package>
</attributes>
</class>

<class>
<name>PvLinuxSystemSupport</name>
<environment>PROVISO</environment>
<super>PROVISO.PvUnixSystemSupport</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports>
			PROVISO.PvLinuxSystemSupportDictionary.*
			</imports>
<category>PV-Support</category>
<attributes>
<includeFiles><item>sys/types.h</item> <item>sys/statvfs.h</item> <item>unistd.h</item> <item>sys/stat.h</item></includeFiles>
<includeDirectories><item>/usr/include</item></includeDirectories>
<libraryFiles><item>libc.so</item> <item>libprovisodc.so</item></libraryFiles>
<libraryDirectories><item>/usr/lib/oracle/10.1.0.3/client/lib</item> <item>/usr/lib/oracle/10.1.0.3/client/lib</item> <item>/home/bbuxton/vw/Green/258.4</item> <item>[unix]/usr/lib</item> <item>[win]$(windir)\system32</item> <item>/home/cmeshare/masters/baseGreen/linux86</item></libraryDirectories>
<beVirtual>false</beVirtual>
<optimizationLevel>debug</optimizationLevel>
<package>PV-Base Extensions</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvLinuxSystemSupport</class-id> <category>api</category>

<body package="PV-Base Extensions" selector="zoneinfoPath">zoneinfoPath
	^'/usr/share/lib/zoneinfo'</body>
</methods>


<methods>
<class-id>PROVISO.PvAIXSystemSupport</class-id> <category>api</category>

<body package="PV-Base Extensions" selector="zoneinfoPath">zoneinfoPath
	^'/usr/share/lib/zoneinfo'</body>
</methods>



<methods>
<class-id>PROVISO.SimpleSerializer</class-id> <category>instantiation</category>

<body package="PV-Support" selector="instantiateSmeeInfinity:">instantiateSmeeInfinity: aClass

	^nil</body>

<body package="PV-Support" selector="instantiateSmeeNotANumber:">instantiateSmeeNotANumber: aClass

	^Smee.SmeeNaN</body>
</methods>

<methods>
<class-id>PROVISO.SimpleSerializer</class-id> <category>reading</category>

<body package="PV-Support" selector="readSmeeString:">readSmeeString: aSmeeString

	aSmeeString value: self read.
	^aSmeeString</body>

<body package="PV-Support" selector="readSmeeObjectProperties:">readSmeeObjectProperties: aSmeeObject 
	
	| sizeOrProperties |
	sizeOrProperties := self read.
	sizeOrProperties isNumber 
		ifFalse: 
			[aSmeeObject smeeProperties: sizeOrProperties.
			^aSmeeObject].
	sizeOrProperties timesRepeat: 
		[| key value |
		key := self read.
		value := self read.
		aSmeeObject 
			smeeAt: key
			put: value].
	^aSmeeObject</body>

<body package="PV-Support" selector="readSmeeInfinity:">readSmeeInfinity: aSmeeInfinity 
	
	^self read 
		ifTrue: [Smee.SmeeInfinity positive]
		ifFalse: [Smee.SmeeInfinity negative]</body>

<body package="PV-Support" selector="readSmeeObject2:">readSmeeObject2: aSmeeObject 
	
	self readSmeeObject: aSmeeObject.
	aSmeeObject smeePrototype: self read.
	^aSmeeObject</body>

<body package="PV-Support" selector="readSmeeArray2:">readSmeeArray2: aSmeeArray 
	
	^self readSmeeObjectProperties: aSmeeArray</body>

<body package="PV-Support" selector="readSmeeDate2:">readSmeeDate2: aSmeeDate 
	
	aSmeeDate value: self read.
	^self readSmeeObject2: aSmeeDate</body>

<body package="PV-Support" selector="readSmeeNullObject:">readSmeeNullObject: aSmeeNull

	^Smee.SmeeNull</body>

<body package="PV-Support" selector="readSmeeNotANumber:">readSmeeNotANumber: aSmeeNotANumber

	^aSmeeNotANumber</body>

<body package="PV-Support" selector="readSmeeObject:">readSmeeObject: aSmeeObject 
	
	^self readSmeeObjectProperties: aSmeeObject</body>
</methods>

<methods>
<class-id>PROVISO.SimpleSerializer</class-id> <category>writing</category>

<body package="PV-Support" selector="writeSmeeString:">writeSmeeString: aSmeeString

	self write: aSmeeString value</body>

<body package="PV-Support" selector="writeSmeeInfinity:">writeSmeeInfinity: aSmeeInfinity

	self write: (aSmeeInfinity &gt; 0)</body>

<body package="PV-Support" selector="writeSmeeDate:">writeSmeeDate: aSmeeDate 
	
	^SimpleSerializerStandIn 
		write: aSmeeDate
		on: self
		read: #readSmeeDate2:
		using: 
			[self write: aSmeeDate value.
			self writeSmeeObjectRaw: aSmeeDate]</body>

<body package="PV-Support" selector="writeSmeeObjectRaw:">writeSmeeObjectRaw: aSmeeObject 
	
	self writeSmeeObjectProperties: aSmeeObject.
	self write: aSmeeObject smeePrototype</body>

<body package="PV-Support" selector="writeSmeeNotANumber:">writeSmeeNotANumber: aSmeeNotANumber

	^aSmeeNotANumber</body>

<body package="PV-Support" selector="writeSmeeObjectProperties:">writeSmeeObjectProperties: aSmeeObject 
	
	| size |
	size := 0.
	aSmeeObject smeeSerializableKeysAndValuesDo: [:key :value | size := size + 1].
	self write: size.
	aSmeeObject smeeSerializableKeysAndValuesDo: 
		[:key :value | 
		self write: key.
		self write: value]</body>

<body package="PV-Support" selector="writeSmeeArray:">writeSmeeArray: aSmeeArray 
	
	^SimpleSerializerStandIn 
		write: aSmeeArray
		on: self
		read: #readSmeeArray2:
		using: 
			[self writeSmeeObjectProperties: aSmeeArray]</body>

<body package="PV-Support" selector="writeSmeeObject:">writeSmeeObject: aSmeeObject 
	
	^SimpleSerializerStandIn 
		write: aSmeeObject
		on: self
		read: #readSmeeObject2:
		using: [self writeSmeeObjectRaw: aSmeeObject]</body>

<body package="PV-Support" selector="writeSmeeNullObject:">writeSmeeNullObject: aSmeeNull

	"do nothing"</body>
</methods>


<methods>
<class-id>PROVISO.PvTimestamp</class-id> <category>arithmetic</category>

<body package="PV-Support" selector="-">- aPvTimestamp 
	
	^Squeak.Duration milliSeconds: 
		self asUTCMilliseconds - aPvTimestamp asUTCMilliseconds</body>
</methods>

<methods>
<class-id>PROVISO.PvTimestamp</class-id> <category>accessing</category>

<body package="PV-Support" selector="yearStartSeconds">yearStartSeconds

	| secondsSince1901 |
	secondsSince1901 := 
		(Date 
			newDay: 1
			monthNumber: 1
			year: self year) asSeconds.
	^secondsSince1901 - SecondsBetween1901and1970.</body>

<body package="PV-Support" selector="yearEndSeconds">yearEndSeconds

	| secondsSince1901 |
	secondsSince1901 := 
		(Date 
			newDay: 1
			monthNumber: 1
			year: self year + 1) asSeconds.
	^secondsSince1901 - SecondsBetween1901and1970 - 1</body>

<body package="PV-Support" selector="yearStopSeconds">yearStopSeconds

	| secondsSince1901 |
	secondsSince1901 := 
		(Date 
			newDay: 1
			monthNumber: 1
			year: self year + 1) asSeconds.
	^secondsSince1901 - SecondsBetween1901and1970</body>
</methods>



<methods>
<class-id>PROVISO.PvFtpResult</class-id> <category>testing</category>

<body package="PV-FTP Client" selector="isError">isError
	
	^self code 
		ifNil: [false]
		ifNotNil: [:myCode | myCode &gt; 399]</body>
</methods>


<methods>
<class-id>PROVISO.PvSecureFtpOverSshClient</class-id> <category>ftp actions</category>

<body package="PV-FTP Client" selector="fileSize:">fileSize: aPath

	| attributes |
	attributes := self remoteStatForFilename: aPath.
	^attributes fileSize.</body>
</methods>


<methods>
<class-id>PROVISO.PvFtpURL</class-id> <category>file utilities</category>

<body package="PV-FTP Client" selector="fileSize">fileSize
	"This seems to be the only reliable way of determining file size"
	
	| retries |
	retries := 0.
	^[self fileDirectoryDoAndClose: 
		[:canonicalUri :client | client fileSize: canonicalUri tail]] 
			on: Error
			do: 
				[:ex | 
				(retries := retries + 1) &lt;= 5 
					ifTrue: [ex retry]
					ifFalse: [ex pass]]</body>
</methods>



<methods>
<class-id>PROVISO.PvrAbstractJournal</class-id> <category>maintenance</category>

<body package="PV-FM-Repository" selector="dropLogsBefore:">dropLogsBefore: logIndex
	"&lt;Integer&gt; Removes (and deletes if the streams are external) all changes and checkpoints prior to the checkpoint at the given checkpointIndex.  Answers an offset that can be applied to an old logIndex to the new log index for a given log."
	"WARNING: Any existing instances of PvrJournalPosition will be invalidated by this method...it is up to clients to adjust existing positions." 

	| offset |
	logIndex = 0 ifTrue: [^self].
	self critical:
		[1 to: logIndex - 1 do:
			[ :i | | strm |
			strm := logs at: i.
			strm close.
			strm isInternal ifFalse:
				[openLogs remove: strm ifAbsent: [].
				strm ioConnection fileName ifNotNil: [:fileName | fileName exists ifTrue: [fileName delete]]]].
		logs := logs copyFrom: logIndex to: logs size.
		logTypes := logTypes copyFrom: logIndex to: logTypes size.
		offset := (logIndex - 1) negated.
		self adjustCachedPositionsBy: offset].
	^offset</body>
</methods>



<methods>
<class-id>PROVISO.PvPersistentObject</class-id> <category>updating</category>

<body package="PV-DM-Support" selector="removeFromModel:">removeFromModel: aPvModel 

	"do nothing"</body>
</methods>


<methods>
<class-id>PROVISO.PvElement</class-id> <category>updating</category>

<body package="PV-DM-Support" selector="removeFromModel:">removeFromModel: aPvModel 
	
	aPvModel elementManager 
		removeItemWithId: self id
		ifAbsent: []</body>
</methods>


<methods>
<class-id>PROVISO.PvRequest class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="selectStatementForFormulasRequestedForSubelementId:forGenericId:">selectStatementForFormulasRequestedForSubelementId: subelementId forGenericId: genericId
	"self dbSession execute: (self 
		selectStatementForFormulasRequestedForSubelementId: 100001738
		forGenericId: 100296198)"

	| namedReplacements |
	namedReplacements := 
		Dictionary new
			at: 'REQUESTTABLE' put: self tableName asString;
			at: 'FORMULATABLE' put: PvFormula tableName asString;
			at: 'SEPATHTABLE' put: PvSubelementGroup groupRelationshipTable;
			at: 'SEMEMBERTABLE' put: PvSubelementGroup groupItemRelationshipTable;
			at: 'SUBELEMENTID' put: subelementId asString;
			at: 'GENERICFORMULAID' put: genericId asString;
			yourself.

	^ 'select t1.idx_formula
		from %REQUESTTABLE t1
		where t1.idx_formula in (
			SELECT idx_ind
  				FROM %FORMULATABLE f
 				WHERE f.str_type IN (''snmp'', ''oid'')
   				AND idx_generic_frml = %GENERICFORMULAID)
			and (
				t1.idx_target = %SUBELEMENTID
					or t1.idx_target in ( 
						select sgg1.idx_group_child
						from %SEPATHTABLE sgg1
						connect by prior sgg1.idx_group_parent = sgg1.idx_group_child
						start with sgg1.idx_group_child in ( 
							select sgm1.idx_group
							from %SEMEMBERTABLE sgm1
							where sgm1.idx_alias_inst = %SUBELEMENTID ) ) )' namedBindWithArguments: namedReplacements</body>
</methods>


<methods>
<class-id>PROVISO.RelationsCollection class</class-id> <category>serialization</category>

<body package="PV-DM-Support" selector="classId">classId

	^61</body>
</methods>


<methods>
<class-id>PROVISO.PvFormula</class-id> <category>xml parsing/generation</category>

<body package="PV-DM-Support" selector="name">name

	^name</body>
</methods>


<methods>
<class-id>PROVISO.PvBaseSubelement</class-id> <category>updating</category>

<body package="PV-DM-Support" selector="removeFromModel:">removeFromModel: aPvModel 
	
	aPvModel subelementManager 
		removeItemWithId: self id
		ifAbsent: []</body>
</methods>


<methods>
<class-id>PROVISO.PvDomainObject</class-id> <category>enumerating</category>

<body package="PV-DM-Support" selector="asRelationsWith:">asRelationsWith: anObject

	^(RelationsCollection new asRelationsWith: self) asRelationsWith: anObject</body>
</methods>


<class>
<name>RelationsCollection</name>
<environment>PROVISO</environment>
<super>PROVISO.PvDomainObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>internal </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>System-Support</category>
<attributes>
<package>PV-DM-Support</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.RelationsCollection</class-id> <category>serialization</category>

<body package="PV-DM-Support" selector="repositoryWriteOn:">repositoryWriteOn: strm 
	super repositoryWriteOn: strm.
	internal size writeNetStringOn: strm.
	internal do: [:each | each repositoryWriteOn: strm]</body>

<body package="PV-DM-Support" selector="repositoryReadFrom:">repositoryReadFrom: strm 
	super repositoryReadFrom: strm.
	internal := Array new: (Integer readNetStringFrom: strm).
	(1 to: internal size) do: 
		[:index | internal at: index put: (PvDomainObject repositoryReadFrom: strm)]</body>

<body package="PV-DM-Support" selector="repositoryRecoverFrom:">repositoryRecoverFrom: strm 
	super repositoryRecoverFrom: strm.
	(Integer readNetStringFrom: strm) timesRepeat: 
		[PvDomainObject repositoryRecoverFrom: strm]</body>
</methods>

<methods>
<class-id>PROVISO.RelationsCollection</class-id> <category>collection</category>

<body package="PV-DM-Support" selector="do:">do: aBlock

	^internal do: aBlock</body>

<body package="PV-DM-Support" selector="last">last

	^internal last</body>

<body package="PV-DM-Support" selector="at:">at: index

	^internal at: index</body>

<body package="PV-DM-Support" selector="size">size

	^internal size</body>

<body package="PV-DM-Support" selector="printOn:">printOn: strm 
	
	self class printOn: strm.
	strm nextPut: $(.
	internal 
		do: [:each | each printOn: strm]
		separatedBy: [strm nextPut: $,].
	strm nextPut: $)</body>

<body package="PV-DM-Support" selector="asSortedCollection:">asSortedCollection: aBlock

	^internal asSortedCollection: aBlock</body>

<body package="PV-DM-Support" selector="select:">select: aBlock

	
	^self pvtShallowCopyWith: (internal select: aBlock)</body>

<body package="PV-DM-Support" selector="first">first

	^internal first</body>

<body package="PV-DM-Support" selector="detect:ifNone:">detect: aBlock ifNone: noneBlock

	^internal detect: aBlock ifNone: noneBlock</body>
</methods>

<methods>
<class-id>PROVISO.RelationsCollection</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="asRelationsWithout:">asRelationsWithout: anObject 
	" Answer the receiver, considered as a
	collection of dependents, with the first
	occurrence of anObject (if any) removed.
	If anObject does not occur in the receiver,
	answer the receiver. "
	" If there is only one dependent left,
	just answer it, rather than a new Collection. "
	
	| newCollection item size indx |
	size := internal size.
	size = 2 
		ifTrue: 
			[((internal at: 1) isEquivalentRelation: anObject) 
				ifTrue: [^internal at: 2]
				ifFalse: 
					[((internal at: 2) isEquivalentRelation: anObject) 
						ifTrue: [^internal at: 1]
						ifFalse: [^self]]].
	newCollection := internal class new: size - 1.
	indx := 1.
	" Search until we find an occurrence of
	anObject, or until we have copied all but
	the last item in the collection. "
	[indx = size or: 
		[item := internal at: indx.
		item isEquivalentRelation: anObject]] 
			whileFalse: 
				[newCollection at: indx put: item.
				indx := indx + 1].
	indx = size 
		ifTrue: 
			[((internal at: size) isEquivalentRelation: anObject) 
				ifTrue: [^self pvtShallowCopyWith: newCollection]]
		ifFalse: 
			[newCollection 
				replaceFrom: indx
				to: size - 1
				with: internal
				startingAt: indx + 1.
			^self pvtShallowCopyWith: newCollection]</body>

<body package="PV-DM-Support" selector="asRelationsWith:">asRelationsWith: anObject 
	
	^(internal anySatisfy: [:each | each isEquivalentRelation: anObject]) 
		ifTrue: [self]
		ifFalse: [self pvtShallowCopyWith: (internal copyWith: anObject)]</body>
</methods>

<methods>
<class-id>PROVISO.RelationsCollection</class-id> <category>initialize-release</category>

<body package="PV-DM-Support" selector="initialize">initialize

	internal := #()</body>
</methods>

<methods>
<class-id>PROVISO.RelationsCollection</class-id> <category>private</category>

<body package="PV-DM-Support" selector="doesNotUnderstand:">doesNotUnderstand: aMessage 
	
	^internal 
		perform: aMessage selector
		withArguments: aMessage arguments</body>

<body package="PV-DM-Support" selector="pvtShallowCopyWith:">pvtShallowCopyWith: newInternal 
	
	^self shallowCopy pvtInternal: newInternal</body>

<body package="PV-DM-Support" selector="pvtInternal:">pvtInternal: anArray

	internal := anArray</body>
</methods>



<methods>
<class-id>PROVISO.UBA.NgFloatMetric</class-id> <category>accessing</category>

<body package="PVAdaptor Core" selector="name:">name: anObject 
	
	super name: (anObject ifNotNil: [:temp | temp smeeToString])</body>
</methods>



<methods>
<class-id>PROVISO.UBA.FecordSchema</class-id> <category>producing</category>

<body package="PVAdaptor-Schema" selector="smeeProduce:">smeeProduce: aRecord 
	&lt;prototypeFunctionNamed: #emitTuple comment: 'Produce a tuple'&gt;
	self rootSchema currentObject adaptor
		ifNil: 
			[self system 
				logWarning: #Warning
				messageId: #DC12358
				text: 'Unable to produce record because no adaptor']
		ifNotNil: [:client | client produceRecord: aRecord]</body>
</methods>



<methods>
<class-id>PROVISO.UBA.UBAServiceInstance</class-id> <category>accessing</category>

<body package="PVAdaptor-Application" selector="runInterval">runInterval
	&lt;getterNamed: #runInterval&gt;
	
	^runInterval ifNil: 
		[runInterval := 
			self configuration 
				numberAt: 'RUNINTERVAL'
				ifAbsent: 
					[self configuration 
						numberAt: 'RUN_INTERVAL'
						ifAbsent: [300]]]</body>
</methods>


<methods>
<class-id>PROVISO.UBA.UBAApplication</class-id> <category>hooks</category>

<body package="PVAdaptor-Application" selector="logTimezoneDatabaseNotLoadedBecauseOf:">logTimezoneDatabaseNotLoadedBecauseOf: ex 
	
	(self testMode or: [self runDebugFlag]) 
		ifFalse: 
			[self system 
				logWarning: #TIME_ZONE_DB_NOT_LOAD
				messageId: #DC10034
				template: 'Reason: &lt;1s&gt;'
				arguments: (Array with: ex messageText)]</body>
</methods>



<methods>
<class-id>PROVISO.PvInventoryPropertyManager</class-id> <category>database queries - private</category>

<body package="PV-NM-Inventory-Application" selector="dbResyncItems:between:and:">dbResyncItems: collectors between: startSeconds and: endSeconds 
 
	| params |
	params := Dictionary new
		at: #collectors put: collectors;
		at: #startSeconds put: startSeconds;
		at: #endSeconds put: endSeconds;
		yourself.
	(self 
		sqlStatementFor: (self itemClass selectStatementWithParametersForInventory: params)
		instanceClass: self itemClass) 
			do: [ :each | self resyncFrom: each]</body>
</methods>


<class>
<name>PvQCF5620PropertyManager</name>
<environment>PROVISO</environment>
<super>PROVISO.PvInventoryPropertyManager</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Managers</category>
<attributes>
<package>PV-NM-Inventory-Application</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvQCF5620PropertyManager</class-id> <category>database queries - private</category>

<body package="PV-NM-Inventory-Application" selector="dbResyncItems:between:and:">dbResyncItems: collectors between: startSeconds and: endSeconds 
 
	| params |
	params := Dictionary new
		at: #collectors put: collectors;
		at: #startSeconds put: startSeconds;
		at: #endSeconds put: endSeconds;
		yourself.
	(self 
		sqlStatementFor: (self itemClass selectStatementWithParametersForQCF5620: params)
		instanceClass: self itemClass) 
			do: [ :each | self resyncFrom: each]</body>
</methods>



<methods>
<class-id>PROVISO.PvProperty class</class-id> <category>database support</category>

<body package="PV-QCF-5620-Application" selector="selectStatementWithParametersForQCF5620:">selectStatementWithParametersForQCF5620: parametersDictionary 
	"(self selectStatementWithParametersForQCF5620: (Dictionary withKeysAndValues: #(startSeconds 0 #endSeconds 1028821796 #collectors #(1 2 3 4 5 6))))"
	"(self selectStatementWithParametersForQCF5620: (Dictionary withKeysAndValues: #(startSeconds 12123123 #endSeconds 1028821796 #collectors #(1 2 3 4 5 6))))"
	"This is the most generic select statement builder in our system.  In order to consolidate the entry point, we will encode special values for building different sql statements.
		If parametersDictionary doesn't include collectorList then we are selecting for all collectors
		if parametersDictionary doesn't include startSeconds, then we are doing a before date select"
	
	| realStartSeconds namedReplacements startSeconds endSeconds collectors |
	startSeconds := 
		parametersDictionary 
			at: #startSeconds
			ifAbsent: [0].
	endSeconds := 
		parametersDictionary 
			at: #endSeconds
			ifAbsent: [self timeFacade now asSeconds].
	collectors := 
		parametersDictionary 
			at: #collectors
			ifAbsent: [nil].
	realStartSeconds := 
		self lastResyncDate isNil 
			ifTrue: [startSeconds]
			ifFalse: [self lastResyncDate + 1].
	namedReplacements := Dictionary new.
	namedReplacements at: 'TABLE' put: self historyTableName asString.
	namedReplacements at: 'ELEMENTHISTORYTABLE' put: PvElement historyTableName asString.
	namedReplacements at: 'SUBELEMENTHISTORYTABLE' put: 
		PvSubelement historyTableName asString.
	startSeconds &gt; 0 
		ifTrue: 
			[namedReplacements at: 'PRIMARYDATECONDITION' put: 	' BETWEEN ' , realStartSeconds asString , ' AND ' , endSeconds asString , ' ']
		ifFalse: 
			[namedReplacements at: 'PRIMARYDATECONDITION' put: ' &lt; ' , endSeconds asString , ' '].
	namedReplacements at: 'HINT' put: ' /*+ NO_MERGE(VIEW1) USE_HASH(VIEW1 t1) ORDERED PUSH_SUBQ ALL_ROWS */ '.
	namedReplacements at: 'SUBQUERYDATECONDITION' put: ' &lt;= ' , endSeconds asString.
	self isHistorical 
		ifTrue: 
			[namedReplacements at: 'COLUMNLIST' put: 
				(self allHistoricalColumnsForSelectWithPrefix: 't1.')]
		ifFalse: 
			[namedReplacements at: 'COLUMNLIST' put: (self allColumnsForSelectWithPrefix: 't1.')].
	(self isFilteredByCollector and: [collectors notNil]) 
		ifTrue: 
			[namedReplacements 
				at: 'COLLECTORCLAUSE'
				put: 
					'e.int_collector IN ' , (self inStatementForCollectors: collectors) asString , 
						' AND ']
		ifFalse: [namedReplacements at: 'COLLECTORCLAUSE' put: ' '].
	^'SELECT %HINT 
		%COLUMNLIST 
	FROM (
			SELECT /*+ push_subq */
				E.idx_ind as idx_ind
			FROM %ELEMENTHISTORYTABLE E
			WHERE %COLLECTORCLAUSE
				E.DTE_DATE = ( SELECT MAX(E1.DTE_DATE)
									FROM %ELEMENTHISTORYTABLE E1
									WHERE E1.IDX_IND = E.IDX_IND
										AND E1.DTE_DATE %SUBQUERYDATECONDITION)
				AND E.STR_ACTION IN (''I'', ''U'')
				AND E.IDX_IND &gt;= -1E10
			UNION ALL
			SELECT /*+ push_subq use_nl(e, se)  */ 
				se.idx_ind as idx_ind
			FROM
				%ELEMENTHISTORYTABLE E,
				%SUBELEMENTHISTORYTABLE SE 
			WHERE %COLLECTORCLAUSE
				E.DTE_DATE = ( SELECT MAX(E1.DTE_DATE)
									FROM %ELEMENTHISTORYTABLE E1
									WHERE E1.IDX_IND = E.IDX_IND
										AND E1.DTE_DATE %SUBQUERYDATECONDITION)
				AND E.STR_ACTION IN (''I'', ''U'')
				AND E.IDX_IND &gt;= -1E10
				AND E.IDX_IND = SE.IDX_HOST
				AND SE.DTE_DATE = ( SELECT MAX(SE1.DTE_DATE)
									FROM %SUBELEMENTHISTORYTABLE SE1
									WHERE SE1.IDX_IND = SE.IDX_IND
										AND SE1.IDX_HOST = SE.IDX_HOST
										AND SE1.DTE_DATE %SUBQUERYDATECONDITION)
				AND SE.STR_ACTION IN (''I'', ''U'')   ) VIEW1,
		%TABLE t1
	WHERE view1.idx_ind = t1.idx_resource
		AND t1.DTE_HIST_DATE = ( SELECT MAX (t2.DTE_HIST_DATE)
									FROM %TABLE t2
									WHERE t1.IDX_METRIC = t2.IDX_METRIC
										AND t1.IDX_RESOURCE = t2.IDX_RESOURCE
										AND t2.DTE_HIST_DATE %PRIMARYDATECONDITION)
		AND t1.DTE_HIST_DATE %PRIMARYDATECONDITION ' namedBindWithArguments: 
			namedReplacements</body>

<body package="PV-QCF-5620-Application" selector="selectStatementWithParametersForInventory:">selectStatementWithParametersForInventory: parametersDictionary 
	"self dbSession execute: 
		(self 
		selectStatementWithParametersForQCF5620: (Dictionary withKeysAndValues: #(startSeconds 0 #endSeconds 1028821796 #collectors #(1))))"
	"This is the most generic select statement builder in our system.  In order to consolidate the entry point, we will encode special values for building different sql statements.
		If parametersDictionary doesn't include collectorList then we are selecting for all collectors
		if parametersDictionary doesn't include startSeconds, then we are doing a before date select"
	
	| realStartSeconds namedReplacements startSeconds endSeconds collectors |
	startSeconds := 
		parametersDictionary 
			at: #startSeconds
			ifAbsent: [0].
	endSeconds := 
		parametersDictionary 
			at: #endSeconds
			ifAbsent: [self timeFacade now asSeconds].
	collectors := 
		parametersDictionary 
			at: #collectors
			ifAbsent: [nil].
	realStartSeconds := 
		self lastResyncDate isNil 
			ifTrue: [startSeconds]
			ifFalse: [self lastResyncDate + 1].
	namedReplacements := Dictionary new.
	namedReplacements at: 'TABLE' put: self historyTableName asString.
	namedReplacements at: 'ELEMENTHISTORYTABLE' put: PvElement historyTableName asString.
	namedReplacements at: 'SUBELEMENTHISTORYTABLE' put: 
		PvSubelement historyTableName asString.
	startSeconds &gt; 0 
		ifTrue: 
			[namedReplacements at: 'PRIMARYDATECONDITION' put: 
				' BETWEEN ' , realStartSeconds asString , ' AND ' , endSeconds asString , ' ']
		ifFalse: 
			[namedReplacements at: 'PRIMARYDATECONDITION' put: ' &lt; ' , endSeconds asString , ' '].
	namedReplacements at: 'SUBQUERYDATECONDITION' put: ' &lt;= ' , endSeconds asString.
	self isHistorical 
		ifTrue: 
			[namedReplacements at: 'COLUMNLIST' put: 
				(self allHistoricalColumnsForSelectWithPrefix: 't1.')]
		ifFalse: 
			[namedReplacements at: 'COLUMNLIST' put: (self allColumnsForSelectWithPrefix: 't1.')].
	(self isFilteredByCollector and: [collectors notNil]) 
		ifTrue: 
			[namedReplacements 
				at: 'COLLECTORCLAUSE'
				put: 
					'e.int_collector IN ' , (self inStatementForCollectors: collectors) asString , 
						' AND ']
		ifFalse: [namedReplacements at: 'COLLECTORCLAUSE' put: ' '].
	^'SELECT /*+ NO_MERGE(VIEW1) USE_NL(VIEW1 t1)  ORDERED */ 
		%COLUMNLIST 
	FROM (
			SELECT /*+ push_subq */
				E.idx_ind as idx_ind
			FROM %ELEMENTHISTORYTABLE E
			WHERE %COLLECTORCLAUSE
				E.DTE_DATE = ( SELECT MAX(E1.DTE_DATE)
									FROM %ELEMENTHISTORYTABLE E1
									WHERE E1.IDX_IND = E.IDX_IND
										AND E1.DTE_DATE %SUBQUERYDATECONDITION)
				AND E.STR_ACTION IN (''I'', ''U'')
				AND E.IDX_IND &gt;= -1E10
			UNION ALL
			SELECT /*+ push_subq use_nl(e, se)  */ 
				se.idx_ind as idx_ind
			FROM
				%ELEMENTHISTORYTABLE E,
				%SUBELEMENTHISTORYTABLE SE 
			WHERE %COLLECTORCLAUSE
				E.DTE_DATE = ( SELECT MAX(E1.DTE_DATE)
									FROM %ELEMENTHISTORYTABLE E1
									WHERE E1.IDX_IND = E.IDX_IND
										AND E1.DTE_DATE %SUBQUERYDATECONDITION)
				AND E.STR_ACTION IN (''I'', ''U'')
				AND E.IDX_IND &gt;= -1E10
				AND E.IDX_IND = SE.IDX_HOST
				AND SE.DTE_DATE = ( SELECT MAX(SE1.DTE_DATE)
									FROM %SUBELEMENTHISTORYTABLE SE1
									WHERE SE1.IDX_IND = SE.IDX_IND
										AND SE1.IDX_HOST = SE.IDX_HOST
										AND SE1.DTE_DATE %SUBQUERYDATECONDITION)
				AND SE.STR_ACTION IN (''I'', ''U'')   ) VIEW1,
		%TABLE t1
	WHERE view1.idx_ind = t1.idx_resource
		AND t1.DTE_HIST_DATE = ( SELECT MAX (t2.DTE_HIST_DATE)
									FROM %TABLE t2
									WHERE t1.IDX_METRIC = t2.IDX_METRIC
										AND t1.IDX_RESOURCE = t2.IDX_RESOURCE
										AND t2.DTE_HIST_DATE %PRIMARYDATECONDITION)
		AND t1.DTE_HIST_DATE %PRIMARYDATECONDITION ' namedBindWithArguments: 
			namedReplacements</body>
</methods>


<methods>
<class-id>PROVISO.PvModel</class-id> <category>initialize-release</category>

<body package="PV-QCF-5620-Application" selector="initializeForQCF5620">initializeForQCF5620
	
	self initOfflineIdManager.
	formulaManager := PvFormulaManager new.
	PROVISO.PvFormulas.PvCflFormula removeUserGeneratedCflFormulaClassess.
	elementManager := PvInventoryElementManager new.
	subelementManager := PvInventorySubelementManager new.
	requestManager := PvRequestManager new.
	thresholdManager := PvInventoryThresholdManager new.
	calendarManager := PvCalendarManager new.
	propertyManager := PvQCF5620PropertyManager new.
	relationManager := PvInventoryRelationManager new.
	dataloadManager := PvDataloadManager new.
	profilesManager := PvProfilesManager new.
	snmpConfigurationManager := PvSnmpConfigurationManager new.
	self makeAllDomainManagersReferToMe.
	self initializeDebugCounters.
	self resyncAgent: (PvModelResyncAgent new pvModel: self; bufferActions: false; yourself).
	self initCollectorsByChannel.
	self loadStatsCollector: false.
	self pvModel formulaManager shouldBuildSmalltalkFormulas: false.</body>
</methods>



<methods>
<class-id>PROVISO.PvModel</class-id> <category>initialize-release</category>

<body package="PV-CWM-Application" selector="initializeForCWM">initializeForCWM
	
	self initOfflineIdManager.
	formulaManager := PvFormulaManager new.
	PROVISO.PvFormulas.PvCflFormula removeUserGeneratedCflFormulaClassess.
	elementManager := PvInventoryElementManager new.
	subelementManager := PvInventorySubelementManager new.
	requestManager := PvRequestManager new.
	thresholdManager := PvInventoryThresholdManager new.
	calendarManager := PvCalendarManager new.
	propertyManager := PvInventoryPropertyManager new.
	relationManager := PvInventoryRelationManager new.
	dataloadManager := PvDataloadManager new.
	profilesManager := PvProfilesManager new.
	snmpConfigurationManager := PvSnmpConfigurationManager new.
	self makeAllDomainManagersReferToMe.
	self initializeDebugCounters.
	self resyncAgent: (PvModelResyncAgent new pvModel: self; bufferActions: false; yourself).
	self initCollectorsByChannel.
	self loadStatsCollector: false.
	self pvModel formulaManager shouldBuildSmalltalkFormulas: false.</body>
</methods>



<methods>
<class-id>PROVISO.PvAbstractSAMInterface</class-id> <category>accessing</category>

<body package="SAM-Interface" selector="secondaryDescriptor">secondaryDescriptor

	^self descriptors at: 2 ifAbsent: [nil]</body>
</methods>


<class>
<name>PvSAMJmsInterface</name>
<environment>PROVISO</environment>
<super>PROVISO.PvObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>sync stdioConnection stdin stdout stderr eventStream externalProcess lastKeepAlive eventCallback stdoutListener stderrListener receivedKeepAlive connection environment inventoryChangeQueue inventoryChangeService lastServerStartTime lock lastKnownId </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>SAM-Interface</category>
<attributes>
<package>SAM-Interface</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>testing</category>

<body package="SAM-Interface" selector="stillAliveIfNotDo:">stillAliveIfNotDo: aBlock 
	
	self isActive 
		ifFalse: 
			[aBlock value: 'SAM JMS external process not active.'.
			^false].
	self isStale 
		ifTrue: 
			[aBlock value: 
				'SAM JMS has not received messages in ' , 
					(self jmsTimeout asMilliSeconds / 1000) asFloat printString , ' seconds'.
			^false].
	^true</body>

<body package="SAM-Interface" selector="hasConnectedSuccessfully">hasConnectedSuccessfully

	^self isActive and: [receivedKeepAlive]</body>

<body package="SAM-Interface" selector="isStale">isStale
	self isInFullDump ifTrue: [^false].
	^(PvTimestamp now - lastKeepAlive) abs &gt; self jmsTimeout</body>

<body package="SAM-Interface" selector="stillAlive">stillAlive
	
	^self stillAliveIfNotDo: [:reason | ]</body>

<body package="SAM-Interface" selector="isActive">isActive
	
	^self critical: [inventoryChangeService isRunning and: 
			[externalProcess 
				ifNil: [false]
				ifNotNil: 
					[:process | 
					process isActive and: 
						[stdioConnection 
							ifNil: [false]
							ifNotNil: [:conn | conn isActive]]]]]</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>initialize-release</category>

<body package="SAM-Interface" selector="initialize">initialize

	super initialize.
	eventCallback := [ :event | ].
	self updateLastKeepAliveTimestamp.
	receivedKeepAlive := false.
	lock := RecursionLock new.
	sync := Semaphore new.
	stdoutListener :=
		Kom.PluggableService new
			name: 'SAM JMS stdout listener';
			runCallback: [ :testBlock | self reportDeathOf: [self processStdout: testBlock] as: 'JMS stdout listener'];
			priority: 45;
			yourself.
	stderrListener :=
		Kom.PluggableService new
			name: 'SAM JMS stderr listener';
			runCallback: [ :testBlock |  self reportDeathOf: [self processStderr: testBlock] as: 'JMS stderr listener'];
			priority: 45;
			yourself.
	self resetInventoryQueue.
	inventoryChangeService := 
		Kom.PluggableService new
			name: 'Inventory Change Service';
			runCallback: [ :testBlock |  self reportDeathOf: [self processInventoryChangeEvents: testBlock] as: 'Inventory change service'];
			priority: 45;
			yourself.</body>

<body package="SAM-Interface" selector="resetInventoryQueue">resetInventoryQueue
	
	inventoryChangeQueue := SharedQueue new</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>constants</category>

<body package="SAM-Interface" selector="terminateClientSessionEventXmlString">terminateClientSessionEventXmlString
	
	^(self jmsEvents keys 
		detect: [:each | each asLowercase includesSubString: 'terminateClientSession']
		ifNone: [#TerminateClientSession]) asString</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>validation</category>

<body package="SAM-Interface" selector="checkSettings">checkSettings
	
	self checkJmsFilter.
	self checkJarPath.
	self checkJavaPath</body>

<body package="SAM-Interface" selector="checkJavaPath">checkJavaPath
	
	self javaPath asFilename ifNotNil: 
		[:file | 
		(file exists and: [file isDirectory not]) 
			ifFalse: 
				[self system 
					logWarning: #JAVA_PATH_DOES_NOT_EXIST
					messageId: #DC10041
					template: 'Does not exist or is not a file: &lt;1s&gt;'
					arguments: (Array with: self javaPath)]]</body>

<body package="SAM-Interface" selector="checkJarPath">checkJarPath
	
	self jarPath asFilename ifNotNil: 
		[:file | 
		(file exists and: [file isDirectory not]) 
			ifFalse: 
				[self system 
					logWarning: #JAR_PATH_DOES_NOT_EXIST
					messageId: #DC10040
					template: 'Does not exist or is not a file: &lt;1s&gt;'
					arguments: (Array with: self jarPath)]]</body>

<body package="SAM-Interface" selector="checkJmsFilter">checkJmsFilter
	
	self filter ifNotNil: 
		[:myFilter | 
		(Array 
			with: self terminateClientSessionEventXmlString
			with: self keepAliveEventXmlString
			with: self stateChangeEventXmlString) do: 
				[:eachRequired | 
				(myFilter includesSubString: eachRequired) 
					ifFalse: 
						[self system 
							logWarning: #REQUIRED_EVENT_MISSING_IN_FILTER
							messageId: #DC10039
							template: 'Needs to be in JMS_FILTER: &lt;1s&gt;'
							arguments: (Array with: eachRequired)]]]</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>accessing</category>

<body package="SAM-Interface" selector="jmsTimeout">jmsTimeout
	"&lt;Duration&gt; Answer the number of seconds that the receiver is allowed to go without a keep alive message from the JMS listener before the listener is considered stale."

	^Squeak.Duration seconds: self descriptor jmsTimeout</body>

<body package="SAM-Interface" selector="jarPath">jarPath
	^self descriptor jarPath</body>

<body package="SAM-Interface" selector="queueId">queueId
	^self descriptor queueId</body>

<body package="SAM-Interface" selector="uri">uri
	^self descriptor jmsURI</body>

<body package="SAM-Interface" selector="fileOutputDirectory">fileOutputDirectory
	^self descriptor fileOutputDirectory</body>

<body package="SAM-Interface" selector="jmsClasses">jmsClasses
	^self descriptor jmsClasses</body>

<body package="SAM-Interface" selector="fileFilter">fileFilter
	^self descriptor fileFilter</body>

<body package="SAM-Interface" selector="jmsProperties">jmsProperties
	^self descriptor jmsProperties</body>

<body package="SAM-Interface" selector="jmsEvents">jmsEvents
	^self descriptor jmsEvents</body>

<body package="SAM-Interface" selector="fileFormat">fileFormat
	^self descriptor fileFormat</body>

<body package="SAM-Interface" selector="password">password
	^self descriptor password</body>

<body package="SAM-Interface" selector="samVersion">samVersion
	^self descriptor samVersion</body>

<body package="SAM-Interface" selector="user">user
	^self descriptor user</body>

<body package="SAM-Interface" selector="descriptor">descriptor

	^connection ifNotNil: [:conn | conn descriptor]</body>

<body package="SAM-Interface" selector="javaPath">javaPath
	^self descriptor javaPath</body>

<body package="SAM-Interface" selector="filter">filter
	^self descriptor jmsFilter</body>

<body package="SAM-Interface" selector="lastKnownId">lastKnownId
	^lastKnownId</body>

<body package="SAM-Interface" selector="lastKnownId:">lastKnownId: anObject 
	
	anObject ifNil: [^self].
	lastKnownId := anObject</body>

<body package="SAM-Interface" selector="inventoryChangeQueue">inventoryChangeQueue

	^inventoryChangeQueue</body>

<body package="SAM-Interface" selector="filePeriod">filePeriod
	^self descriptor filePeriod</body>

<body package="SAM-Interface" selector="shouldDebug">shouldDebug
	^self descriptor jmsShouldDebug ifNil: [false]</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>starting and stopping</category>

<body package="SAM-Interface" selector="sendFileOutputCommands">sendFileOutputCommands
	
	self descriptor activeFileOutputsDo: 
		[:name :eachFileOutput | 
		eachFileOutput nameFormat ifNotNil: 
			[:format | 
			self 
				cmdAddFileFormat: format
				for: name].
		eachFileOutput outputDirectory ifNotNil: 
			[:outputDir | 
			self 
				cmdAddFileOutputDirectory: outputDir
				for: name].
		eachFileOutput period ifNotNil: 
			[:period | 
			self 
				cmdAddFilePeriod: period
				for: name].
		eachFileOutput filter ifNotNil: 
			[:filter | 
			self 
				cmdAddFileFilter: filter
				for: name]]</body>

<body package="SAM-Interface" selector="stop">stop
	
	self critical: 
		[self stop: inventoryChangeService.
		self stopExternalProcess.
		ObjectMemory removeDependent: self]</body>

<body package="SAM-Interface" selector="forceRestartOrSwitch:">forceRestartOrSwitch: shouldFork 
	
	| block |
	block := 
		self hasConnectedSuccessfully 
			ifTrue: [[self forceRestart]]
			ifFalse: [[self forceSwitch]].
	shouldFork 
		ifTrue: [block fork]
		ifFalse: [block value]</body>

<body package="SAM-Interface" selector="start">start
	
	self uri ifNil: [^self].
	self checkSettings.
	self critical: 
		[self isActive ifTrue: [^self].
		ObjectMemory addDependent: self.
		self resetInventoryQueue.
		self startExternalProcess.
		self restart: inventoryChangeService]</body>

<body package="SAM-Interface" selector="stopExternalProcess">stopExternalProcess
	
	| process |
	self critical: 
		[self stop: stderrListener.
		self stop: stdoutListener.
		process := externalProcess ifNil: [^self].
		process isActive 
			ifTrue: 
				[self cmdQuit.
				(Delay forSeconds: 1) wait]].
	self waitForExternalProcessToStop: (self basicStopExternalProcess: process).
	sync signalAll.</body>

<body package="SAM-Interface" selector="update:with:from:">update: anAspect with: arguments from: anObject
	"Shut down the external process when the image is exiting"

	anAspect == #aboutToQuit
		ifTrue: 
			[[self stop] on: Error do: [:ex | ]]</body>

<body package="SAM-Interface" selector="startExternalProcess">startExternalProcess
	
	| args |
	args := 
		Array 
			with: '-jar'
			with: self jarPath
			with: self uri host , ':' , self uri port asString.
	externalProcess ifNotNil: [self stopExternalProcess].
	self critical: 
		[receivedKeepAlive := false.
		stdioConnection := 
			ExternalProcess defaultClass 
				pipeConnectionWithErrorFor: self javaPath
				arguments: args
				setProcessDescriptor: [:p | externalProcess := p].
		self logProcessStarted: externalProcess pid.
		stdin := stdioConnection writeStream.
		stdout := stdioConnection readStream.
		stderr := stdioConnection errorReadStream.
		self updateLastKeepAliveTimestamp.
		self restart: stderrListener.
		self restart: stdoutListener.
		"Only do the following if we talking to the 2.1 jms interface."
		self samVersion = '2.1' 
			ifTrue: 
				[self cmdAddUser: self user.
				self cmdAddPassword: self hashedPassword.
				self cmdAddQueueId: self queueId].
		self samVersion = '3.0' 
			ifTrue: 
				[self cmdAddUser: self user.
				self cmdAddPassword: self password pvDecrypt.
				self cmdAddQueueId: self queueId.
				self cmdAddFilter: self filter]
			ifFalse: 
				[self jmsClasses do: [:ea | self cmdAddClass: ea].
				self jmsProperties do: [:ea | self cmdAddProperty: ea]]].
	self cmdAddDebug: self shouldDebug.
	self sendFileOutputCommands</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>processing</category>

<body package="SAM-Interface" selector="processEvent:">processEvent: strm 
	"Process a string coming from the JMS interface (this could be an event or heartbeat)"
	
	| event tmp |
	strm next.
	"Consume the 'C'"
	self environment do: [event := Smee.SmeeArray new].
	[strm atEnd] 
		whileFalse: 
			[tmp := String readNetStringFrom: strm.
			tmp = self keepAliveEventString 
				ifTrue: [^self processKeepAlive].
			tmp = self stateChangeEventString 
				ifTrue: [^self processStateChangeEvent: strm].
			tmp = self generalExceptionString 
				ifTrue: [^self].
			tmp = self jmsExceptionString 
				ifTrue: [^self processJmsException: strm].
			tmp := 
				tmp 
					copyFrom: 2
					to: tmp size.
			event add: tmp].
	self doEvent: event</body>

<body package="SAM-Interface" selector="doEvent:">doEvent: event 
	
	self doInventoryChange: 
		[[self eventCallback value: event] 
			on: Error
			do: [:ex | self logEventProcessingError: ex]]</body>

<body package="SAM-Interface" selector="processStateChangeXmlEvent:objectType:">processStateChangeXmlEvent: anElement objectType: aType 
	
	| result primaryIP startTime subResult secondaryIP |
	(self isMissedJmsEvent: anElement) 
		ifTrue: 
			[self descriptor schema processFullDumpFor: self connection samInterface.
			^#()].
	result := 
		self 
			processXmlEvent: anElement
			objectType: aType.
	result size ~= 4 
		ifTrue: [^result].
	subResult := result at: 4.
	subResult isEmpty 
		ifTrue: [^result].
	primaryIP := 
		subResult first 
			at: 'sysPrimaryIp'
			ifAbsent: [nil].
	self 
		updateDescriptor: self connection samInterface primaryDescriptor
		with: primaryIP.
	secondaryIP := 
		subResult first 
			at: 'sysStandbyIp'
			ifAbsent: [nil].
	self 
		updateDescriptor: self connection samInterface secondaryDescriptor
		with: secondaryIP.
	startTime := 
		(subResult first 
			at: 'sysStartTime'
			ifAbsent: [^result]) asNumber.
	self runFullDumpIfNeeded: startTime.
	^result</body>

<body package="SAM-Interface" selector="markFullDumpInterrupted">markFullDumpInterrupted
	
	self forceFullDumpOnRestart.
	self forceRestartOrSwitch: true.</body>

<body package="SAM-Interface" selector="processTerminateClientSession">processTerminateClientSession
	"attempt to immediately reconnect"
	
	self forceRestartOrSwitch: true</body>

<body package="SAM-Interface" selector="runFullDumpIfNeeded:">runFullDumpIfNeeded: startTime 
	
	(self isFullDumpNeeded: startTime) 
		ifTrue: 
			[self descriptor schema processFullDumpFor: self connection samInterface.
			lastServerStartTime := startTime]</body>

<body package="SAM-Interface" selector="processXmlEvent:objectType:eventType:objectName:">processXmlEvent: anElement
	objectType: anObjectType
	eventType: anEventType
	objectName: anObjectName
	
	| eventColl |
	eventColl := OrderedCollection new.
	eventColl
		add: anEventType;
		add: anObjectType;
		add: anObjectName.
	self 
		processFilteredXmlEvent: anElement
		eventType: anEventType
		into: eventColl.
	self doEvent: eventColl.
	^eventColl</body>

<body package="SAM-Interface" selector="manageActiveServerDataFrom:">manageActiveServerDataFrom: aColl 
	
	| dataLists data anIP |
	aColl size = 4 
		ifFalse: [^self].
	(dataLists := aColl at: 4) isEmpty 
		ifTrue: [^self].
	data := dataLists first.
	anIP := 
		data 
			at: 'sysPrimaryIp'
			ifAbsent: [].
	self currentApplication server setActiveServer: anIP</body>

<body package="SAM-Interface" selector="forceFullDumpOnRestart">forceFullDumpOnRestart
	
	lastServerStartTime := nil</body>

<body package="SAM-Interface" selector="processJmsException:">processJmsException: strm 
	"Process a jms exception string coming from the JMS interface"
	
	| tmp |
	tmp := String readNetStringFrom: strm.
	self processErr: tmp.
	self forceRestartOrSwitch: true.</body>

<body package="SAM-Interface" selector="processXmlEvent:">processXmlEvent: strm 
	"Process an xml element coming from the JMS interface (this could be an event or heartbeat)"
	
	| aType anElement id |
	strm next.
	"Consume the 'X'"

	[anElement := XML.XMLParser new parseElement: strm.
	id := self getIdFrom: strm.
	self lastKnownId: id.
	aType := self getObjectType: anElement.
	aType = self keepAliveEventXmlString 
		ifTrue: 
			[self processKeepAlive.
			^self 
				processXmlEvent: anElement
				objectType: aType
				eventType: aType
				objectName: nil].
	aType = self terminateClientSessionEventXmlString 
		ifTrue: [^self processTerminateClientSession].
	self updateLastKeepAliveTimestamp.
	aType = self stateChangeEventXmlString 
		ifTrue: 
			[^self 
				processStateChangeXmlEvent: anElement
				objectType: aType].
	^(self jmsClasses includes: aType) 
		ifTrue: 
			[self 
				processXmlEvent: anElement
				objectType: aType]
		ifFalse: 
			[self 
				processXmlEvent: anElement
				objectType: aType
				eventType: 'IgnoredEvent'
				objectName: nil]] 
					on: Error
					do: [:ex | self logEventProcessingError: ex]</body>

<body package="SAM-Interface" selector="updateLastKeepAliveTimestamp">updateLastKeepAliveTimestamp
	
	lastKeepAlive := PvTimestamp now</body>

<body package="SAM-Interface" selector="isMissedJmsEvent:">isMissedJmsEvent: anElement 
	
		| tag body |
	body := 
		anElement anyElementNamed: 
			(XML.NodeTag 
				qualifier: ''
				ns: 'xmlapi_1.0'
				type: 'jms').
	body ifNotNil: 
		[tag := 
			body anyElementNamed: 
				(XML.NodeTag 
					qualifier: ''
					ns: 'xmlapi_1.0'
					type: 'state')].
	(tag isNil or: [tag elements isEmpty]) 
		ifTrue: [^nil].
	^tag elements first text includesSubString: 'jmsMissedEvent'</body>

<body package="SAM-Interface" selector="doInventoryChange:">doInventoryChange: aBlock

	inventoryChangeQueue nextPut: aBlock</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>private</category>

<body package="SAM-Interface" selector="forceSwitch">forceSwitch
	
	self connection ifNotNil: 
		[:conn | 
		conn samInterface ifNotNil: 
			[:samInterface | 
			self stop.
			(Delay forSeconds: 10) wait.
			samInterface setNextDescriptor.
			self forceFullDumpOnRestart.
			self start]]</body>

<body package="SAM-Interface" selector="getIdFrom:">getIdFrom: strm 
	
	strm upTo: $&lt;.
		(strm atEnd not and: [(strm next: 3) = '!--']) 
			ifTrue: [^strm upTo: $-].
	^nil</body>

<body package="SAM-Interface" selector="waitForExternalProcessToStop:">waitForExternalProcessToStop: extProc

	| pid |
	extProc ifNil: [^self].
	pid := extProc pid.

	"Now, wait for the external process to die (logging messages if it refuses)"
	[[extProc wait.
	true]
		timeoutSeconds: 60
		onTimeout: 
			[self logStuckProcess: pid.
			false]] whileFalse.

	self logProcessStopped: pid.</body>

<body package="SAM-Interface" selector="reportDeathOf:as:">reportDeathOf: aBlock as: aString 
	
	aBlock 
		on: Error
		do: 
			[:ex | 
			self processErr: aString , ' died: ' , ex description.
			self forceRestartOrSwitch: true]</body>

<body package="SAM-Interface" selector="isFullDumpNeeded:">isFullDumpNeeded: startTime 
	
	"a;lways return true until we can distinguish between new and old subscriptions on JMS connection"
	"^self attemptResync or: 
		[lastServerStartTime isNil or: [lastServerStartTime ~= startTime]]"
	^true</body>

<body package="SAM-Interface" selector="forceRestart">forceRestart
	
	self stop.
	(Delay forSeconds: 5) wait.
	self start</body>

<body package="SAM-Interface" selector="isInFullDump">isInFullDump
	
	^self connection 
		ifNil: [false]
		ifNotNil: 
			[:conn | 
			conn samInterface 
				ifNil: [false]
				ifNotNil: [:samInterface | samInterface isInFullDump ifNil: [false]]]</body>

<body package="SAM-Interface" selector="restart:">restart: aService

	self stop: aService.
	aService start</body>

<body package="SAM-Interface" selector="stop:">stop: aService

	aService stop.
	aService waitForStopForSeconds: 1.
	aService isStopped ifFalse: [aService kill].</body>

<body package="SAM-Interface" selector="processStrings:do:while:">processStrings: stringCallback do: processCallback while: testBlock 
	"This method is called by the eventService and is designed to run forever, reading infomration from the pipe connection with the external JMS listener process"
	
	| str |
	[testBlock value] 
		whileTrue: 
			[[str := stringCallback value] 
				timeoutSeconds: 1
				onTimeout: [str := nil].
			str 
				ifNil: [sync waitTimeoutMilliseconds: 500]
				ifNotNil: [Process unsafeRegion: [processCallback value: str]]]</body>

<body package="SAM-Interface" selector="updateDescriptor:with:">updateDescriptor: aDescriptor with: anIpString 
	
	"aDescriptor ifNil: [^self].
	anIpString ifNil: [^self].
	#(soapURI jmsURI exportURI) do: 
		[:each | 
		(aDescriptor perform: each) ifNotNil: 
			[:uri | 
			uri 
				host: anIpString
				port: uri port]]"</body>

<body package="SAM-Interface" selector="attemptResync">attemptResync
	
	^self connection 
		ifNil: [false]
		ifNotNil: 
			[:conn | 
			conn samInterface 
				ifNil: [false]
				ifNotNil: [:samInterface | samInterface attemptResync ifNil: [true]]]</body>

<body package="SAM-Interface" selector="critical:">critical: aBlock

	^lock critical: aBlock</body>

<body package="SAM-Interface" selector="cleanInventoryQueue">cleanInventoryQueue
	
	[inventoryChangeQueue isEmpty] 
		whileFalse: [inventoryChangeQueue nextNoWait]</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>process management</category>

<body package="SAM-Interface" selector="processInventoryChangeEvents:">processInventoryChangeEvents: testBlock 
	
	[testBlock value] 
		whileTrue: [self processNextInventoryChangeEvent]</body>

<body package="SAM-Interface" selector="processStderr:">processStderr: testBlock 
	"This method is called by the eventService and is designed to run forever, reading infomration from the pipe connection with the external JMS listener process"
	
	self 
		processStrings: [self getStringFrom: stderr onError: [:ex | ]]
		do: [:str | self processErr: str]
		while: [testBlock value and: [self isActive]]</body>

<body package="SAM-Interface" selector="processStdout:">processStdout: testBlock 
	"This method is called by the eventService and is designed to run forever, reading infomration from the pipe connection with the external JMS listener process"
	
	self 
		processStrings: 
			[self 
				getStringFrom: stdout
				onError: 
					[:ex | 
					self cmdResendAfterLastKnownId]]
		do: [:str | self process: str]
		while: [testBlock value and: [self isActive]]</body>

<body package="SAM-Interface" selector="getStringFrom:onError:">getStringFrom: aStream onError: aOneArgumentBlock 
	
	aStream ifNil: [^nil].
	^[aStream peek ifNotNil: [String readNetStringFrom: aStream]] 
		on: Error
		do: 
			[:ex | 
			aStream setToEnd.
			aOneArgumentBlock value: ex.
			nil]</body>

<body package="SAM-Interface" selector="basicStopExternalProcess:">basicStopExternalProcess: process

	[stdioConnection close] on: Error do: [:ex | ].
	[process kill: 9] on: Error do: [ :ex | ].
	externalProcess := stdioConnection := stdin := stdout := stderr := nil.
	^process</body>

<body package="SAM-Interface" selector="processNextInventoryChangeEvent">processNextInventoryChangeEvent
	
	^(inventoryChangeQueue nextAvailable: 1) do: [:each | each value]</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>commands</category>

<body package="SAM-Interface" selector="cmdResendAfterLastKnownId">cmdResendAfterLastKnownId
	
	self lastKnownId ifNotNil: 
		[:lastId | 
		self sendCommand: 
			((String new: 200) streamContentsDo: 
				[:strm | 
				strm nextPut: $C.
				'SRESENDAFTER' writeNetStringOn: strm.
				'S' , lastId writeNetStringOn: strm])]</body>

<body package="SAM-Interface" selector="cmdAddFileFilter:for:">cmdAddFileFilter: aString for: aName

	self sendCommand: 
		((String new: 200) streamContentsDo:
			[ :strm |
			strm nextPut: $C.
			('SADDFILEFILTER.', aName) writeNetStringOn: strm.
			('S', aString) writeNetStringOn: strm])</body>

<body package="SAM-Interface" selector="cmdAddDebug:">cmdAddDebug: aBoolean 
	
	self sendCommand: 
		((String new: 200) streamContentsDo: 
			[:strm | 
			strm nextPut: $C.
			'SDEBUG' writeNetStringOn: strm.
			'S' , aBoolean printString asUppercase writeNetStringOn: strm])</body>

<body package="SAM-Interface" selector="cmdAddFilter:">cmdAddFilter: aFilterString

	self sendCommand: 
		((String new: 200) streamContentsDo:
			[ :strm |
			strm nextPut: $C.
			'SADDFILTER' writeNetStringOn: strm.
			('S',aFilterString) writeNetStringOn: strm])</body>

<body package="SAM-Interface" selector="cmdAddFileOutputDirectory:for:">cmdAddFileOutputDirectory: aString for: aName

	self sendCommand: 
		((String new: 200) streamContentsDo:
			[ :strm |
			strm nextPut: $C.
			('SADDFILEOUTPUTDIR.', aName) writeNetStringOn: strm.
			('S', aString) writeNetStringOn: strm])</body>

<body package="SAM-Interface" selector="sendCommand:">sendCommand: aString 
	"Transcript show: 'COMMAND: ', aString;cr."
	
	[stdin ifNotNil: 
		[:s | 
		aString writeNetStringOn: s.
		[s flush] 
			timeoutSeconds: 5
			onTimeout: [self doInventoryChange: [self sendCommand: aString]].
		self system 
			logDebugFour: #JMS_STDCMD
			messageId: nil
			template: '&lt;1s&gt;'
			arguments: (Array with: aString)]] 
				on: Error
				do: 
					[:ex | 
					self processErr: ex description.
					self forceRestartOrSwitch: true]</body>

<body package="SAM-Interface" selector="cmdAddFileFormat:for:">cmdAddFileFormat: aString for: aName

	self sendCommand: 
		((String new: 200) streamContentsDo:
			[ :strm |
			strm nextPut: $C.
			('SADDFILEFORMAT.', aName) writeNetStringOn: strm.
			('S', aString) writeNetStringOn: strm])</body>

<body package="SAM-Interface" selector="cmdAddFilePeriod:for:">cmdAddFilePeriod: aString for: aName

	self sendCommand: 
		((String new: 200) streamContentsDo:
			[ :strm |
			strm nextPut: $C.
			('SADDFILEPERIOD.', aName) writeNetStringOn: strm.
			('S', aString) writeNetStringOn: strm])</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMJmsInterface</class-id> <category>logging</category>

<body package="SAM-Interface" selector="logProcessStarted:">logProcessStarted: pid
	&lt;comment: 'The SAM JMS communication process has stopped.'&gt;
	&lt;probableCause: 'The system has started or is trying to recover from errors in the SAM JMS process.'&gt;
	&lt;suggestedAction: 'No action required.'&gt;

	self currentApplication setStatusMessage: 'SAM JMS communication process listening for events since: ', self timeFacade now printString.
	self system
		logDebugThree: #JMS_PROCESS_STARTED
		messageId: #DL39218
		template: ##('The SAM JMS communication process has started (pid: &lt;1s:process id&gt;)' asLogTemplate)
		arguments: [{pid printString ifNil: ['unknown']}]</body>

<body package="SAM-Interface" selector="logStaleJMSConnection">logStaleJMSConnection
	&lt;comment: 'The SAM JMS keep-alive timeout has been exceeded, the JMS process will be restarted.'&gt;
	&lt;probableCause: 'The JMS connection has been dropped and no keep-alive messages are being received'&gt;
	&lt;suggestedAction: 'Check SAM server availability.'&gt;

	self system
		logWarning: #JMS_CONNECTION_STALE
		messageId: #DL39223
		template: ##('The SAM JMS connection is stale, the JMS process will be restarted.' asLogTemplate)
		arguments: #()</body>

<body package="SAM-Interface" selector="logProtocolError:">logProtocolError: anException 
	&lt;comment: 'An error occurred in the SAM JMS communication protocol'&gt;
	&lt;probableCause: 'The SAM JMS process died.'&gt;
	&lt;suggestedAction: 'Contact technical support'&gt;
	
	self system 
		logWarning: #SAM_JMS_PROTOCOL_ERROR
		messageId: #DL39217
		template: 
			##('There was an error communicating with the SAM interface &lt;1s:uri&gt;: &lt;2s:message&gt;' asLogTemplate)
		arguments: 
			[Array 
				with: self uri asString
				with: anException description].
	(self system debugFlags 
		at: #DEBUG_WALKBACK_ON_INPUT_ERROR
		ifAbsent: 
			[self system debugFlags 
				at: #DEBUG_WALKBACK_ON_ADAPTOR_ERROR
				ifAbsent: [true]]) 
					ifTrue: [PvWalkbackWriter new dumpWalkbackForException: anException]</body>

<body package="SAM-Interface" selector="logProcessStopped:">logProcessStopped: pid
	&lt;comment: 'The SAM JMS communication process has stopped.'&gt;
	&lt;probableCause: 'The SAM JMS process became unresponsive.'&gt;
	&lt;suggestedAction: 'No action required.'&gt;

	self currentApplication setStatusMessage: 'SAM JMS communication process stopped listening for events at ', self timeFacade now printString.
	self system
		logDebugThree: #JMS_PROCESS_STOPPED
		messageId: #DL39219
		template: ##('The SAM JMS communication process has stopped (pid: &lt;1s:process id&gt;)' asLogTemplate)
		arguments: [{pid printString ifNil: ['unknown']}]</body>

<body package="SAM-Interface" selector="logEventProcessingError:">logEventProcessingError: ex
	&lt;comment: 'An error occurred while processing a JMS event.'&gt;
	&lt;probableCause: 'Un-expected data in the JMS event or a bug in the AppPack event processing callback.'&gt;
	&lt;suggestedAction: 'Contact your system administrator.'&gt;

	self system
		logWarning: #JMS_EVENT_ERROR
		messageId: #DL39224
		template: ##('Error processing JMS event: &lt;1s:error description&gt;' asLogTemplate)
		arguments: {ex description}</body>
</methods>


<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvSAMJmsInterface</class-id> <selector>filter:</selector>
</remove-selector>

<remove-selector>
<class-id>Root.Smalltalk.PROVISO.PvSAMJmsInterface</class-id> <selector>getStringFrom:</selector>
</remove-selector>

<methods>
<class-id>PROVISO.PvSAMJmsInterface class</class-id> <category>creation</category>

<body package="SAM-Interface" selector="on:">on: aJmsConnection

	^self new
		connection: aJmsConnection;
		yourself</body>
</methods>


<class>
<name>PvSAMDeviceConnection</name>
<environment>PROVISO</environment>
<super>PROVISO.PvObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>mutex client domainModel jmsInterface samInterface </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>SAM-Interface</category>
<attributes>
<package>SAM-Interface</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvSAMDeviceConnection</class-id> <category>connection</category>

<body package="SAM-Interface" selector="jmsInterfaceClass">jmsInterfaceClass
	
	^PvSAMJmsInterface</body>

<body package="SAM-Interface" selector="basicConnect">basicConnect
	"&lt;self&gt; Create an HttpClient and try to ping the server...an exception will be signaled if there is any problem"
	
	self critical: 
		[self client: self newClient.
		self descriptor jmsURI ifNotNil: 
			[self jmsInterface: (self jmsInterfaceClass on: self).
			self setEventCallbackBlock]]</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMDeviceConnection</class-id> <category>testing</category>

<body package="SAM-Interface" selector="jmsStillAlive">jmsStillAlive
	
	^self jmsInterface 
		ifNil: [false]
		ifNotNil: [:jms | jms stillAlive]</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMDeviceConnection</class-id> <category>private</category>

<body package="SAM-Interface" selector="logSendError:">logSendError: error 
	
	self system 
		logWarning: #SEND_ERROR
		messageId: #DC10014
		text: error description</body>

<body package="SAM-Interface" selector="refreshClient">refreshClient
	
	self client disconnect.
	self client: self newClient.
	^self</body>

<body package="SAM-Interface" selector="sendAndRetry:">sendAndRetry: request 
	
	| retries |
	retries := 0.
	^[self client request: request.
	self client executeAndGetResponse] 
		on: Error
		do: 
			[:httpIssue | 
			retries := retries + 1.
			retries &lt;= 5 
				ifTrue: 
					[self reconnect.
					(Delay forMilliseconds: 500) wait.
					httpIssue retry]
				ifFalse: [httpIssue pass]]</body>

<body package="SAM-Interface" selector="send:">send: aString 
	"&lt;HttpResponse&gt; Send the given XML string to the server and get the response...if we fail, try to disconnect the current client, create a new client, and resend the request."
	
	^self samInterface haPerform: 
		[:aConnection | 
		aConnection refreshClient.
		aConnection 
			send: aString
			timeout: self soapTimeout]</body>

<body package="SAM-Interface" selector="send:timeout:">send: aString timeout: msecs 
	"&lt;HttpResponse&gt; Send the given XML string to the server and get the response...if we fail, try to disconnect the current client, create a new client, and resend the request.

	NOTE: we may need to fork the #executeAndGetResponse in the future so that we can kill it if it takes longer than the timeout to execute"
	
	| request |
	request := self newRequestWithContents: aString.
	^self critical: 
		[[self sendAndRetry: request] 
			on: Error
			do: 
				[:error | 
				self logSendError: error.
				self serverUnreachable: error description]]</body>
</methods>


<class>
<name>PvSAMDeviceDescriptor</name>
<environment>PROVISO</environment>
<super>PROVISO.PvObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>soapURI exportURI jmsURI javaPath jarPath jmsClasses jmsProperties jmsTimeout user password schema samVersion queueId soapTimeout jmsFilter jmsEvents connectionWaitTime fileFormat filePeriod fileOutputDirectory fileFilter fileOutputs jmsShouldDebug </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>SAM-Interface</category>
<attributes>
<package>SAM-Interface</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvSAMDeviceDescriptor</class-id> <category>initialize-release</category>

<body package="SAM-Interface" selector="initializeFileOutputs">initializeFileOutputs
	
	| config |
	config := 
		self schema environment configuration selectConfigurationFor: 
			self schema name asUppercase , '.JMS_FILE_OUTPUT'.
	config keysAndValuesDo: 
		[:fullKey :value | 
		| keyStream outputName key |
		keyStream := fullKey readStream.
		outputName := keyStream upTo: $..
		key := keyStream upToEnd.
		key isEmpty ifTrue: [key := '1'].
		(self fileOutputNamed: outputName) 
			setKey: key
			value: value]</body>

<body package="SAM-Interface" selector="initialize">initialize
	"Initialize a newly created instance. This method must answer the receiver."

	super initialize.
	jmsClasses := #().
	jmsProperties := #().
      jmsEvents := Dictionary new.
	fileOutputs := Dictionary new.</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMDeviceDescriptor</class-id> <category>accessing</category>

<body package="SAM-Interface" selector="filePeriod">filePeriod
	^filePeriod</body>

<body package="SAM-Interface" selector="fileOutputDirectory">fileOutputDirectory
	^fileOutputDirectory</body>

<body package="SAM-Interface" selector="fileOutputNamed:">fileOutputNamed: aString 
	
	^fileOutputs 
		at: aString
		ifAbsentPut: [PvSAMFileOutputDescriptor new]</body>

<body package="SAM-Interface" selector="fileFilter">fileFilter
	^fileFilter</body>

<body package="SAM-Interface" selector="jmsShouldDebug:">jmsShouldDebug: aBoolean

	jmsShouldDebug := aBoolean</body>

<body package="SAM-Interface" selector="fileFormat">fileFormat
	^fileFormat</body>

<body package="SAM-Interface" selector="jmsShouldDebug">jmsShouldDebug

	^jmsShouldDebug</body>

<body package="SAM-Interface" selector="activeFileOutputsDo:">activeFileOutputsDo: aDyadic 
	
	^self fileOutputsDo: 
		[:name :fileOutputDesc | 
		fileOutputDesc isActive 
			ifTrue: 
				[aDyadic 
					value: name
					value: fileOutputDesc]]</body>

<body package="SAM-Interface" selector="fileOutputsDo:">fileOutputsDo: aDyadic 
	
	^fileOutputs keysAndValuesDo: aDyadic</body>
</methods>


<class>
<name>PvSAMFileOutputDescriptor</name>
<environment>PROVISO</environment>
<super>PROVISO.PvObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>nameFormat outputDirectory period filter isActive </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>SAM-Interface</category>
<attributes>
<package>SAM-Interface</package>
</attributes>
</class>

<methods>
<class-id>Root.Smalltalk.PROVISO.PvSAMFileOutputDescriptor</class-id> <category>public</category>

<body package="SAM-Interface" selector="setKey:value:">setKey: aKey value: aValue 
	
	(self class 
		setterFor: aKey
		ifAbsent: [[:desc :ignore | nil ]]) 
			value: self
			value: aValue</body>
</methods>

<methods>
<class-id>Root.Smalltalk.PROVISO.PvSAMFileOutputDescriptor</class-id> <category>accessing</category>

<body package="SAM-Interface" selector="isActiveFromString:">isActiveFromString: aString
	self isActive: (self convertToBoolean: aString)</body>

<body package="SAM-Interface" selector="isActive:">isActive: anObject
	isActive := anObject</body>

<body package="SAM-Interface" selector="outputDirectory">outputDirectory
	^outputDirectory</body>

<body package="SAM-Interface" selector="isActive">isActive
	
	^isActive ifNil: [true]</body>

<body package="SAM-Interface" selector="filter:">filter: anObject
	filter := anObject</body>

<body package="SAM-Interface" selector="nameFormat:">nameFormat: anObject
	nameFormat := anObject</body>

<body package="SAM-Interface" selector="filter">filter
	^filter</body>

<body package="SAM-Interface" selector="outputDirectory:">outputDirectory: anObject
	outputDirectory := anObject</body>

<body package="SAM-Interface" selector="nameFormat">nameFormat
	^nameFormat</body>

<body package="SAM-Interface" selector="period">period
	^period</body>

<body package="SAM-Interface" selector="period:">period: anObject
	period := anObject</body>
</methods>

<methods>
<class-id>Root.Smalltalk.PROVISO.PvSAMFileOutputDescriptor</class-id> <category>private</category>

<body package="SAM-Interface" selector="convertToBoolean:">convertToBoolean: aString
	"Need to call PvConfiguration class&gt;&gt;convertToBoolean:"
	"Not doing so now so that SAM can be shared across all releases"
	^#('Y' 'YES' 'TRUE' 'T'  '1') includes: aString asUppercase trimBlanks</body>
</methods>


<methods>
<class-id>Root.Smalltalk.PROVISO.PvSAMFileOutputDescriptor class</class-id> <category>config</category>

<body package="SAM-Interface" selector="setterMap">setterMap
	
	^##(Dictionary new
		at: 'FILTER' put: #filter:;
		at: 'NAME_FORMAT' put: #nameFormat:;
		at: 'OUTPUT_DIRECTORY' put: #outputDirectory:;
		at: 'PERIOD' put: #period:;
		at: 'ACTIVE' put: #isActiveFromString:;
		yourself)</body>

<body package="SAM-Interface" selector="setterFor:ifAbsent:">setterFor: aKey ifAbsent: aBlock 
	
	^self setterMap 
		at: aKey
		ifAbsent: aBlock</body>
</methods>


<methods>
<class-id>PROVISO.UBA.PvSAMDeviceSchema</class-id> <category>parsing</category>

<body package="SAM-Interface" selector="stop">stop
	
	connection ifNotNil: [connection disconnect].
	self domainModel ifNotNil: 
		[:model | model connection ifNotNil: [:modelConn | modelConn disconnect]]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.PvSAMDeviceSchema</class-id> <category>accessing</category>

<body package="SAM-Interface" selector="jmsFileFormat">jmsFileFormat
	&lt;getterNamed: #jmsFileFormat&gt;
	
	^self environment configuration 
		stringAt: self name asUppercase , '.JMS_FILE_FORMAT'
		ifAbsent: [nil]</body>

<body package="SAM-Interface" selector="jmsFileOutputDirectory">jmsFileOutputDirectory
	&lt;getterNamed: #jmsFileOutputDirectory&gt;
	
	^self environment configuration 
		stringAt: self name asUppercase , '.JMS_FILE_OUTPUT_DIRECTORY'
		ifAbsent: [nil]</body>

<body package="SAM-Interface" selector="jmsFileFilter">jmsFileFilter
	&lt;getterNamed: #jmsFileFilter&gt;
	
	^self environment configuration 
		stringAt: self name asUppercase , '.JMS_FILE_FILTER'
		ifAbsent: [nil]</body>

<body package="SAM-Interface" selector="jmsShouldDebug">jmsShouldDebug
	&lt;getterNamed: #jmsDebug&gt;
	
	^self environment configuration 
		booleanAt: self name asUppercase , '.JMS_DEBUG'
		ifAbsent: [false]</body>

<body package="SAM-Interface" selector="primaryDescriptor">primaryDescriptor
	
	| aDescriptor |
	aDescriptor := PvSAMDeviceDescriptor new.
	aDescriptor
		schema: self;
		user: self username;
		password: self password;
		soapURI: self soapUri;
		soapTimeout: self soapTimeout;
		exportURI: self exportUri;
		jmsURI: self jmsUri;
		javaPath: self javaPath;
		samVersion: self samVersion;
		jarPath: self jarPath;
		jmsClasses: self jmsClasses;
		jmsProperties: self jmsProperties;
		jmsEvents: self jmsEvents;
		jmsTimeout: self jmsTimeout;
		jmsShouldDebug: self jmsShouldDebug;
		queueId: self queueId;
		jmsFilter: self jmsFilter;
		connectionWaitTime: self connectionWaitTime;
		initializeFileOutputs.
	^aDescriptor</body>

<body package="SAM-Interface" selector="secondaryDescriptor">secondaryDescriptor
	
	| aDescriptor |
	self soapUri2 isNil 
		ifTrue: [^nil].
	aDescriptor := self primaryDescriptor.
	aDescriptor
		soapURI: self soapUri2;
		exportURI: self exportUri2;
		jmsURI: self jmsUri2.
	^aDescriptor</body>

<body package="SAM-Interface" selector="jmsFilePeriod">jmsFilePeriod
	&lt;getterNamed: #jmsFilePeriod&gt;
	
	^self environment configuration 
		stringAt: self name asUppercase , '.JMS_FILE_PERIOD'
		ifAbsent: [nil]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.PvSAMDeviceSchema</class-id> <category>enumerating</category>

<body package="SAM-Interface" selector="processFullDumpFor:">processFullDumpFor: anInterface 
	
	| retries |
	retries := 0.
	anInterface connection ifNotNil: 
		[:conn | 
		conn jmsInterface doInventoryChange: 
			[self adaptor environmentDo: 
				[[conn jmsInterface cleanInventoryQueue.
				anInterface preFullDump.
				self onFullDump valueWithThis: self.
				conn jmsInterface updateLastKeepAliveTimestamp.
				anInterface postFullDump] 
					on: Error
					do: 
						[:ex | 
						(ex isResumable or: [ex isKindOf: SmeeError]) 
							ifFalse: 
								[(self timeFacade delayForMilliseconds: 500) wait.
								retries &lt; 10 
									ifTrue: 
										[retries := retries + 1.
										self logFullDumpRetried: ex.
										ex retry]].
						self logFullDumpInterrupted: ex.
						anInterface markNotInFullDump.
						conn jmsInterface markFullDumpInterrupted]]]].
	^'A full dump has been scheduled'</body>
</methods>

<methods>
<class-id>PROVISO.UBA.PvSAMDeviceSchema</class-id> <category>logging</category>

<body package="SAM-Interface" selector="logFullDumpRetried:">logFullDumpRetried: ex
	&lt;comment: 'A full dump of inventory objects had an error and is being retried.'&gt;
	&lt;probableCause: 'A communications interruption with the server'&gt;
	&lt;suggestedAction: 'Initiate another full dump.'&gt;

	self system
		logDebugFour: #FULL_DUMP_RETRIED
		messageId: #DL39002
		template: ##('Full inventory dump is being retried due to the following reason: &lt;1s:problem description&gt;)' asLogTemplate)
		arguments: [{ex description}]</body>
</methods>


<class>
<name>PvSAMInterface</name>
<environment>PROVISO</environment>
<super>PROVISO.PvAbstractSAMInterface</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>primarySwitchOverPollInterval lastPrimarySwitchOverAttempt connection attemptResync environment inFullDump isAutoResyncAllowed </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>SAM-Interface</category>
<attributes>
<package>SAM-Interface</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvSAMInterface</class-id> <category>testing</category>

<body package="SAM-Interface" selector="isAutoResyncAllowed">isAutoResyncAllowed
	
	isAutoResyncAllowed isNil 
		ifTrue: 
			[isAutoResyncAllowed := 
				self currentApplication mergedConfiguration 
					booleanAt: 'AUTO_FULL_DUMP'
					ifAbsent: [true]].
	^isAutoResyncAllowed</body>

<body package="SAM-Interface" selector="jmsStillAlive">jmsStillAlive
	
	^connection 
		ifNil: [false]
		ifNotNil: [:conn | conn jmsStillAlive]</body>

<body package="SAM-Interface" selector="isInFullDump">isInFullDump

	^inFullDump</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMInterface</class-id> <category>initialize-release</category>

<body package="SAM-Interface" selector="initialize">initialize
	
	super initialize.
	self attemptResync: true.
	lastPrimarySwitchOverAttempt = 0.
	primarySwitchOverPollInterval = 60.
	inFullDump := false.</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMInterface</class-id> <category>accessing</category>

<body package="SAM-Interface" selector="fullDumpOnStartup">fullDumpOnStartup
	" should we do a full-dump on startup "

	^self currentApplication mergedConfiguration
		booleanAt: 'FULLDUMP_ONSTARTUP'
		ifAbsent: [true]</body>

<body package="SAM-Interface" selector="markNotInFullDump">markNotInFullDump

	inFullDump := false</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMInterface</class-id> <category>actions</category>

<body package="SAM-Interface" selector="setActiveServer:">setActiveServer: aServer 
	
	self system 
		logWarning: #SAM_CONNECT
		messageId: nil
		text: 'SAM State change event received...Current active SAM server is ' , aServer.
	(IpAddress fromString: self descriptor soapURI host) asString = aServer 
		ifTrue: [^false].
	self
		setNextDescriptor;
		disconnect;
		tryReconnectInTurnUntilSuccessful</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMInterface</class-id> <category>private</category>

<body package="SAM-Interface" selector="cleanupTempDirectory">cleanupTempDirectory
	"cleanup temp dir for now...no need to move files to done in this case"
	|  tempDirectory |
	tempDirectory := ForeignDomainMethod basicNew exportFilenameLocalDirectory.
	tempDirectory exists 
		ifFalse: [^self].
	tempDirectory deepDelete</body>
</methods>

<methods>
<class-id>PROVISO.PvSAMInterface</class-id> <category>enumerating</category>

<body package="SAM-Interface" selector="disconnect">disconnect
	
	connection disconnect</body>

<body package="SAM-Interface" selector="testConnection">testConnection
	
	self jmsStillAlive ifTrue: [^true].
	connection := self connect.
	self system 
		logInfo: #SAM_CONNECT
		messageId: nil
		text: 'Attempting connection to sam server: ' , self descriptor soapURI asString.
	^[connection testConnection.
	true] 
		on: Error
		do: 
			[:err | 
			self system 
				logInfo: #SAM_CONNECT
				messageId: nil
				text: 
					'Connection to sam server failed on ' , self descriptor soapURI asString , '. ' , 
						err messageText printString.
			false]</body>

<body package="SAM-Interface" selector="shouldAttemptPrimarySwitchOver">shouldAttemptPrimarySwitchOver
	"subclasses should override to detect availability of the primary cwm server and attempt to reestablish a connection to the primary"
	
	^self isInFullDump not and: 
		[self currentDescriptorPosition ~= 1 and: 
			[self timeFacade now asSeconds - self lastPrimarySwitchOverAttempt &gt;= 
				self primarySwitchOverPollInterval]]</body>

<body package="SAM-Interface" selector="basicCheckForPrimaryAvailability">basicCheckForPrimaryAvailability
	
	| oldConnection oldPosition |
	self system 
		logWarning: #SAM_CHECK_PRIMARY
		messageId: #DC10617
		text: 'Check for primary SAM server availability'.
	self lastPrimarySwitchOverAttempt: self timeFacade now asSeconds.
	oldPosition := self currentDescriptorPosition.
	"oldDescriptor := self descriptor."
	self currentDescriptorPosition: 1.
	oldConnection := connection.
	self testConnection 
		ifFalse: 
			[connection disconnect.
			self 
				rollbackCurrentConnection: oldConnection
				using: oldPosition.
			^self].
	oldConnection notNil 
		ifTrue: [oldConnection disconnect].
	"self deactivateDescriptor: oldDescriptor."
	self activateSwitchedConnection</body>

<body package="SAM-Interface" selector="preFullDump">preFullDump
	
	self currentApplication setStatusMessage: 
		'SAM full dump started at: ' , self timeFacade now printString.
	"self stopJms."
	"this is no longer needed because JMS should always be up"
	self cleanupTempDirectory.
	self attemptResync: true.
	inFullDump := true</body>

<body package="SAM-Interface" selector="haPerform:">haPerform: aBlock 
	
	| retries |
	retries := 0.
	^self critical: 
		[self isInFullDump ifTrue: [^aBlock value: self connection].
		self tryReconnectInTurnUntilSuccessful.
		[self waitUntilReady.
		
		aBlock value: self connection] 
			on: PvSAMDeviceConnection serverUnreachableError
			do: 
				[:ex | 
				self connection disconnect.
				self system 
				logInfo: #SAM_CONNECT
				messageId: nil
				text: 
					'Connection to sam server was lost due to the following error: ' ,	ex messageText printString,'...Retrying connection.'.
				(self 
					test: self normalStateId
					set: self connectingStateId) 
						ifTrue: 
							[self tryReconnectInTurnUntilSuccessful.
							self state: self normalStateId].
				(self timeFacade delayForMilliseconds: 20) wait.
				retries := retries + 1.
				(retries \\ 10 = 0 and: 
					[self system debugFlags at: #DEBUG_WALKBACK_ON_INPUT_ERROR ifAbsent: [false]]) 
						ifTrue: [PvWalkbackWriter new dumpWalkbackForException: ex].
				self startJms.
				ex retry]]</body>

<body package="SAM-Interface" selector="activateSwitchedConnection">activateSwitchedConnection
	
	self activateDescriptor: self descriptor.
	self attemptResync: true.
	self system 
		logWarning: #SAM_RESTORED_PRIMARY
		messageId: #DC10620
		text: 'Successfully switched back to primary SAM server'</body>

<body package="SAM-Interface" selector="activateDescriptor:">activateDescriptor: aDescriptor 
	"enable this connection"
	
	self startJms</body>

<body package="SAM-Interface" selector="checkForPrimaryAvailability">checkForPrimaryAvailability
	
	self shouldAttemptPrimarySwitchOver 
		ifFalse: [^self].
	self isInFullDump 
		ifTrue: [^self].
	self basicCheckForPrimaryAvailability</body>

<body package="SAM-Interface" selector="peformFullResync">peformFullResync
	
	self attemptResync 
		ifTrue: [self critical: [self privateResync]]</body>

<body package="SAM-Interface" selector="rollbackCurrentConnection:using:">rollbackCurrentConnection: oldConnection using: oldPosition 
	
	self currentDescriptorPosition: oldPosition.
	connection := oldConnection.
	self system 
		logWarning: #SAM_PRIMARY_UNAVAILABLE
		messageId: #DC10619
		text: 'Failed to connect to SAM service.'</body>

<body package="SAM-Interface" selector="postFullDump">postFullDump
	
	self currentApplication ifNotNil: 
		[:anApp | anApp setStatusMessage: 'SAM full dump ended at: ' , self timeFacade now printString].
	"self startJms."
	"this is no longer needed because JMS should always be up"
	self attemptResync: false.
	inFullDump := false</body>

<body package="SAM-Interface" selector="tryReconnectInTurnUntilSuccessful">tryReconnectInTurnUntilSuccessful
	&lt;comment: 'Switching from specified device to the backup device started' 
	probableCause: 'Attempt to recover from a SAM server connection failure' 
	suggestedAction: 'No action required'&gt;
	
	| timeout wasConnected |
	wasConnected := connection notNil.
	(wasConnected and: [connection isConnected]) 
		ifTrue: [^self].
	(self timeFacade delayForSeconds: 1) wait.
	timeout := self delayBetweenConnectionRetries.
	[self testConnection] 
		whileFalse: 
			[self disconnect.
			self deactivateDescriptor: self descriptor.
			connection := nil.
			self currentApplication setStatusMessage: 
				'Waiting for ' , timeout printString , ' seconds before next connection attempt'.
			(self timeFacade delayForSeconds: timeout) wait.
			self isStandalone 
				ifFalse: 
					[self system 
						logWarning: #SAM_BEGIN_SWITCH
						messageId: #DC10624
						template: 'Switching from SAM SOAP service: &lt;1s&gt; to alternate service.'
						arguments: (Array with: self descriptor soapURI printString).
					wasConnected := self attemptResync: true.
					self setNextDescriptor]].
	self activateDescriptor: self descriptor.
	self lastPrimarySwitchOverAttempt: self timeFacade now asSeconds.
	self system 
		logInfo: #SAM_CONNECTED
		messageId: nil
		text: 'Connection established with ' , self descriptor soapURI asString</body>

<body package="SAM-Interface" selector="startJms">startJms
	
	connection ifNotNil: [connection jmsInterface ifNotNil: [:jms | jms stillAlive ifFalse: [jms start]]]</body>
</methods>



<methods>
<class-id>PROVISO.SamifServiceInstance</class-id> <category>private</category>

<body package="SAM-Application" selector="connectionUsing:do:">connectionUsing: aSchema do: aBlock 
	
	aSchema samInterface ifNotNil: 
		[:samInterface | samInterface connection ifNotNil: aBlock]</body>
</methods>

<methods>
<class-id>PROVISO.SamifServiceInstance</class-id> <category>restart</category>

<body package="SAM-Application" selector="isConnectionStillAliveFor:ifNotDo:">isConnectionStillAliveFor: aSchema ifNotDo: aBlock 
	
	self 
		connectionUsing: aSchema
		do: 
			[:schemaConnection | 
			(schemaConnection 
				ifNil: [false]
				ifNotNil: [:conn | conn isConnected]) 
					ifFalse: 
						[aBlock value: 'SOAP HTTP connection broken.'.
						^false].
			(schemaConnection jmsInterface 
				ifNil: [false]
				ifNotNil: [:interface | interface stillAliveIfNotDo: aBlock]) 
					ifFalse: [^false]].
	^true</body>

<body package="SAM-Application" selector="restartIfNeeded">restartIfNeeded
	
	[self samDeviceSchemaDo: 
		[:schema | 
		(self 
			isConnectionStillAliveFor: schema
			ifNotDo: [:reason | self logRestartNeededBecause: reason]) 
				ifFalse: [self forceRestartOrSwitch].
		"simply do an haPerform: and it will do the right thing"
		schema samInterface haPerform: [:conn | ]]] 
			on: Error
			do: [:ex | "ignore"]</body>

<body package="SAM-Application" selector="logRestartNeededBecause:">logRestartNeededBecause: reason
	
	self system 
		logDebugFour: #RESTART_NEEDED
		messageId: #DC10013
		text: 'Restarting Because SAM Processes Down: ', reason</body>
</methods>



<methods>
<class-id>PROVISO.SimpleSerializer</class-id> <category>writing</category>

<body package="NGUBA-Support" selector="writeRecord:">writeRecord: aRecord

	self writeSmeeObjectProperties: aRecord</body>
</methods>

<methods>
<class-id>PROVISO.SimpleSerializer</class-id> <category>reading</category>

<body package="NGUBA-Support" selector="readRecord:">readRecord: aRecord

	^self readSmeeObjectProperties: aRecord</body>
</methods>



<methods>
<class-id>PROVISO.UBA.MetricWriter</class-id> <category>private</category>

<body package="NGUBA-Application" selector="setFormulaFromName:">setFormulaFromName: aMetric 
	
	| formulaName |
	formulaName := aMetric name smeeToString.
	(formulaName notEmpty and: [formulaName first == $~]) 
		ifTrue: 
			[formulaName := formulaName allButFirst.
			aMetric name: formulaName].
	^(self pvModel formulaNamed: formulaName) ifNotNil: 
		[:formula | aMetric formula: formula]</body>

<body package="NGUBA-Application" selector="makeSureMetricHasProperConnections:">makeSureMetricHasProperConnections: aMetric 
	
	aMetric formula ifNil: [self setFormulaFromName: aMetric].
	(aMetric resource notNil and: [aMetric resource id isNil]) 
		ifTrue: 
			[(self pvModel subelementNamed: aMetric resource name smeeToString) ifNotNil: 
				[:resource | aMetric resource: resource]].
	aMetric resource 
		ifNil: [aMetric resource: (self pvModel subelementWithId: aMetric resourceId)]
		ifNotNil: [aMetric resourceId ifNil: [aMetric resourceId: aMetric resource id]].
	aMetric collectorNumber ifNil: 
		[aMetric collectorNumber: 
			(aMetric resource 
				ifNil: [nil]
				ifNotNil: [:resource | resource collectorNumber])].
	aMetric collectorNumber ifNil: [aMetric collectorNumber: self collectorNumber]</body>

<body package="NGUBA-Application" selector="isMetricValid:">isMetricValid: aMetric 
	
	aMetric value ifNil: 
		[self 
			logInvalidMetric: aMetric
			reason: 'Undefined value'.
		^false].
	aMetric resourceId ifNil: 
		[self 
			logInvalidMetric: aMetric
			reason: 'Undefined resource id'.
		^false].
	aMetric formulaId ifNil: 
		[self 
			logInvalidMetric: aMetric
			reason: 'Undefined formula'.
		^false].
	aMetric collectorNumber ifNil: 
		[self 
			logInvalidMetric: aMetric
			reason: 'Undefined collector number'.
		^false].
	^true</body>
</methods>



</st-source>
